// Klac - complex

#ifndef IG_KLAC_MODULECLASS_COMPLEX_AS
#define IG_KLAC_MODULECLASS_COMPLEX_AS

#include "MCVar.as"
#include "MCAssoc.as"

//##############################################################################
//                W[
//##############################################################################
#module MCComplex

#include "enum_valtype.as"
#include "header_inner.as"

#define VAR_TEMP _stt_temp@MCComplex

#define ctype RegularizeArg(%1) (((%1) \ M_PI2 + M_PI2) \ M_PI2)

// @static
	dim VAR_TEMP
	
//##########################################################
//                \zE
//##########################################################
//------------------------------------------------
// \z
// 
// @ l (0, 0.0)
//------------------------------------------------
#deffunc complex_New var self, int iEnv
	assoc_New    self, iEnv
	
	// oǉ
	assoc_DefVar self, "prototype", (stt_assoc_complex), Valtype_Assoc
	
	assoc_DefVar self, "#size", 0,   Valtype_Int		// <: (int | double)
	assoc_DefVar self, "#arg",  0.0, Valtype_Double		// <: double
	
;	plugin_complex_DefinePropaties self
	
	return self
	
// ֐`
#defcfunc new_complex int iEnv,  local self
	complex_New self, iEnv
	return self
	
//  (arg = 0.0)
#defcfunc new_complex_real double size, int iEnv,  local self
	complex_New      self, iEnv
	complex_set_size self, size
	return self
	
// Pʉ~ (size = 1)
#defcfunc new_complex_unit double arg, int iEnv,  local self
	complex_New self, iEnv
	
	var_Set complex_size_v(self), 1, Valtype_Int
	complex_set_arg self, arg
	
	return self
	
//------------------------------------------------
// j
//------------------------------------------------
#deffunc complex_Delete int self
	assoc_Delete self
	return
	
//##########################################################
//                
//##########################################################

//##########################################################
//                擾
//##########################################################
//------------------------------------------------
// 𓾂
//------------------------------------------------
#defcfunc complex_GetEnv int self
	return assoc_GetEnv(self)
	
//------------------------------------------------
// o̎擾 @private
// 
// @ ϐ iVar Ԃ
//------------------------------------------------
#defcfunc complex_size_v@MCComplex int self
	return assoc_Find( self, "#size" )
	
#defcfunc complex_arg_v@MCComplex int self
	return assoc_Find( self, "#arg" )
	
#deffunc complex_size_Clone@MCComplex int self, var clone
	var_Clone complex_size_v(self), clone
	return
	
#deffunc complex_arg_Clone@MCComplex int self, var clone
	var_Clone complex_arg_v(self), clone
	return
	
//------------------------------------------------
// o̒l̎擾
//------------------------------------------------
// Ɍ`
#defcfunc complex_size int self
	return var_Get( complex_size_v(self) )
	
#defcfunc complex_arg int self
	return var_Get( complex_arg_v(self) )
	
#deffunc complex_get_byPolar int self, var size, var arg
	size = complex_size(self)
	arg  = complex_arg (self)
	return
	
// W
#defcfunc complex_re int self,   local tmp
	return cos( complex_arg(self) ) * complex_size(self)
	
#defcfunc complex_im int self,  local tmp
	return sin( complex_arg(self) ) * complex_size(self)
	
#deffunc complex_get_byRect int self, var re, var im,  local size, local arg
	complex_get_byPolar self, size, arg
	re = cos(arg) * size
	im = sin(arg) * size
	return
	
// size
#defcfunc complex_sizeType int self
	return var_GetType( complex_size_v(self) )
	
#defcfunc complex_sizeValue int self, var resVt
	return var_GetValue( complex_size_v(self), resVt )
	
//------------------------------------------------
// oւ̑
//------------------------------------------------
#deffunc complex_set_size int self,  double size_,  local size, local vt
	
	if ( size_ == 0 ) {
		complex_Clear self
		return
		
	} elsif ( size_ < 0 ) {
		size = -size_		// 
		complex_Minus self	// 
		
	} else {
		size = size_
	}
	
	vt = Valtype_Double
	StrCalc_ArithCnvDown size, vt
	
	var_Set complex_size_v(self), size, vt
	return
	
#deffunc complex_set_arg int self, double val
	var_Set complex_arg_v(self), RegularizeArg(val), Valtype_Double
	return
	
#deffunc complex_set_re int self, double re
	complex_set_byRect self, re, complex_im(self)
	return
	
#deffunc complex_set_im int self, double im
	complex_set_byRect self, complex_re(self), im
	return
	
//------------------------------------------------
// 
//------------------------------------------------
#defcfunc complex_IsInt int self
	return ( complex_IsRe(self) && IsDoubleInt(complex_size(self)) )
	
#defcfunc complex_IsRe int self
	return ( complex_arg(self) \ M_PI == 0 )
	
#defcfunc complex_IsIm int self
	return ( complex_arg(self) \ M_PI != 0 )
	
#defcfunc complex_IsPure int self
	return toIntIfNear( cos(complex_arg(self)) ) == 0
	
//------------------------------------------------
// ʕϊ
//------------------------------------------------
#defcfunc complex_CnvDown int self, var resVt,  local size, local arg
	arg = complex_arg(self)
	
	if ( arg \ M_PI == 0 ) {
		size = complex_size(self)
		
		if ( arg == M_PI ) {
			size *= -1
		}
		if ( IsDoubleInt(size) ) {
			resVt = Valtype_Int    : return int(size)
		} else {
			resVt = Valtype_Double : return size
		}
	}
	
	resVt = Valtype_Assoc
	return self

//##########################################################
//                
//##########################################################
//------------------------------------------------
// Ɍ`
//------------------------------------------------
#deffunc complex_set_byPolar int self, double size, double arg
	if ( size == 0 ) {
		complex_Clear self
	} else {
		complex_set_size self, size
		complex_set_arg  self, arg
	}
	return
	
//------------------------------------------------
// W`
//------------------------------------------------
#deffunc complex_set_byRect int self, double re, double im
	complex_set_byPolar self, sqrt( re * re + im * im ), argof( re, im )
	return
	
//##########################################################
//                Z
//##########################################################
//------------------------------------------------
// 
//------------------------------------------------
#deffunc complex_Plus int self
	return
	
#deffunc complex_Minus int self,  local clArg
	complex_arg_Clone self, clArg : clArg = RegularizeArg( clArg + M_PI )
	return
	
//------------------------------------------------
// 
// 
// @ //z = (rEe^(i))^(1/2) = (r)Ee^(i(/2))
//------------------------------------------------
#deffunc complex_Sqrt int self,  local clArg
	complex_set_size  self, sqrt(complex_size(self))	// ^ int -> double ɂȂ\邽߃N[Ȃ
	complex_arg_Clone self, clArg : clArg /= 2			// clArg/2  [0, 2)  RegularizeArg sv
	return
	
//------------------------------------------------
// t(^-1)
// 
// @ /z = (rEe^(i))^(-1) = (r^-1)Ee^(i(-))
//------------------------------------------------
#deffunc complex_Inv int self,  local clArg
	complex_set_size  self, 1.0 / complex_size(self)
	complex_Conjugate self
	return
	
//------------------------------------------------
// 
// 
// @ ~z = P(a + ib)
// @	= a - ib
// @	= rEcos - i r sin 
// @	= rEcos(-) + r sin(-)
// @	= rEe(i(-))
//------------------------------------------------
#deffunc complex_Conjugate int self,  local clArg
	complex_arg_Clone self, clArg : clArg = RegularizeArg( -clArg )
	return
	
//------------------------------------------------
// 
//------------------------------------------------
#deffunc complex_Add int self, int rhs,  local lhsPair, local rhsPair
	ddim lhsPair, 2
	ddim rhsPair, 2
	complex_get_byRect self, lhsPair(0), lhsPair(1)
	complex_get_byRect rhs,  rhsPair(0), rhsPair(1)
	complex_set_byRect self, lhsPair(0) + rhsPair(0), lhsPair(1) + rhsPair(1)
	return
	
#deffunc complex_Sub int self, int rhs,  local lhsPair, local rhsPair
	ddim lhsPair, 2
	ddim rhsPair, 2
	complex_get_byRect self, lhsPair(0), lhsPair(1)
	complex_get_byRect rhs,  rhsPair(0), rhsPair(1)
	complex_set_byRect self, lhsPair(0) - rhsPair(0), lhsPair(1) - rhsPair(1)
	return
	
//------------------------------------------------
// 揜
//------------------------------------------------
#deffunc complex_MulWithReal int self, double r		// {
	complex_set_size self, r * complex_size(self)
	return
	
#deffunc complex_Mul int self, int rhs,  local clArg
	complex_set_size  self, double( complex_size(self) ) * complex_size(rhs)
	complex_arg_Clone self, clArg : clArg = RegularizeArg( clArg + complex_arg(rhs) )
	return
	
#deffunc complex_Div int self, int rhs,  local clArg
	complex_set_size  self, double( complex_size(self) ) / complex_size(rhs)
	complex_arg_Clone self, clArg : clArg = RegularizeArg( clArg - complex_arg(rhs) )
	return
	
//------------------------------------------------
// 
//------------------------------------------------

//------------------------------------------------
// p
// 
// @ lhs = 0 ? (rhs = 0 ? 1 : 0)
// @ lhs^rhs
// @	= (rEe^(it))^(a + ib)
// @	= (r^aEe^(-bt))Ee^(i(bElog r + at))
//------------------------------------------------
#deffunc complex_Pow int self, int rhs,  local r, local t, local a, local b
	complex_get_byPolar self, r, t
	complex_get_byRect  rhs,  a, b
	
	complex_PowImpl self, r, t, a, b
	return
	
#deffunc complex_PowWithReal int self, double x,  local r, local t
	complex_get_byPolar self, r, t
	complex_PowImpl     self, r, t, x, 0	// 
	return
	
#deffunc complex_PowImpl int self, double r, double t, double a, double b
	if ( r == 0 ) {
		if ( a == 0 && b == 0 ) {
			complex_set_byPolar self, 1, 0
		} else {
			complex_Clear self
		}
	} else {
		complex_set_byPolar self, ( powf(r, a) / expf(b * t) ), ( b * logf(r) + a * t )
	}
	return
	
#deffunc complex_Exp int self,  local a, local b
	complex_get_byRect self, a, b
;	complex_PowImpl    self, M_E, 0, a, b	// e^self
	complex_set_byPolar self, expf(a), b	// e^(a + i b) = e^a * e^(i b)
	return
	
//------------------------------------------------
// p
// 
// @ lhs//rhs = rhs^(/lhs)
//------------------------------------------------
#deffunc complex_Root int self, int rhs,  local r, local t, local a, local b, local s
	complex_get_byPolar self, r, t
	complex_get_byRect  rhs,  a, b
	
	// (a + ib) ̋tƂ
	s = (a * a + b * b)
	complex_PowImpl self, r, t, a / s, -b / s
	return
	
#deffunc complex_RootWithReal int self, double x
	complex_PowWithReal self, 1.0 / x
	return
	
//------------------------------------------------
// ΐ
// 
// @ * log[a](x) = ln(x) / ln(a)	# ϊ̌
// @ * ln (rEe^(i)) = ln r + i	# log ̈Ӗ
// @ 1. log[a](rEe^(i))			# a <: {R}
// @	= (ln r + i) / ln(a)
// @	= ln(r - a) + i( / ln(a))
// @ 2. log[aEe^(ib)](cEe^(id))	# f
// @	= (ln c + id) / (ln a + ib)
//------------------------------------------------
#defcfunc complex_Log int self, int base,  local coef, local prm
	complex_set_byRect self, logf(complex_size(self) - base), complex_arg(self) / logf(base)
	return
	
#defcfunc complex_Ln int self, double base,  local coef, local prm
	complex_set_byRect self, logf(complex_size(self)), complex_arg(self)
	return
	
#defcfunc complex_LogWithReal int self, double base,  local coef, local prm
	complex_set_byRect self, logf(complex_size(self) - base), complex_arg(self) / logf(base)
	return
	
//------------------------------------------------
// Op֐
// 
// @ sin z = sin(x + iy) = (sin x)(cosh y) + i(cos x)(sinh y)
// @ cos z = cos(x + iy) = (cos x)(cosh y) - i(sin x)(sinh y)
// @ tan z = (sin z) / (cos z)
//------------------------------------------------
#deffunc complex_sin int self,  local x, local y
	complex_get_byRect self, x, y
	complex_set_byRect self, sin(x) * cosh(y), cos(x) * sinh(y)
	return
	
#deffunc complex_cos int self,  local x, local y
	complex_get_byRect self, x, y
	complex_set_byRect self, cos(x) * cosh(y), - sin(x) * sinh(y)
	return
	
#deffunc complex_tan int self,  local x
	x = complex_Dup(self)
	complex_cos x
	complex_sin self
	complex_Div self, x
	return
	
//------------------------------------------------
// r
// 
// @result: rl
//------------------------------------------------
#defcfunc complex_Cmp int self, int rhs,  local size, local arg
	size = complex_size(self), complex_size(rhs)
	arg  = complex_arg (self), complex_arg (rhs)
	
	return ( sgn(size(0) - size(1)) * 2 + sgn(arg(0) - arg(1)) )
	
//##########################################################
//                Rei
//##########################################################

//------------------------------------------------
// 
//------------------------------------------------
#deffunc complex_Clear int self
	var_Set complex_size_v(self), 0,   Valtype_Int
	var_Set complex_arg_v (self), 0.0, Valtype_Double
	return
	
//------------------------------------------------
// 
//------------------------------------------------
#defcfunc complex_Dup int self,   local obj
	complex_new         obj, complex_GetEnv(self)
	complex_set_byPolar obj, complex_size(self), complex_arg(self)
	return obj
	
#global

#endif
