// Dmath.as

#ifndef IG_DMATH_AS
#define IG_DMATH_AS

#module Dmath

//------------------------------------------------
// hspmath.as
//------------------------------------------------
// 萔
#undef M_PI
#define global M_E      2.7182818284590452354		; e
#define global M_LOG2E  1.4426950408889634074		; log_2(e)
#define global M_LOG10E 0.43429448190325182765		; log_10(e)
#define global M_LN2    0.69314718055994530942		; log_e(2)
#define global M_LN10   2.30258509299404568402		; log_e(10)
#define global M_PI     3.14159265358979323846264	; 
#define global M_SQRTPI 1.77245385090551602792981	; 
#define global M_SQRT2  1.41421356237309504880		; 2
#define global M_SQRT3  1.73205080756887719000		; 3

// double ̌x
#const  global DBL_DIG         15									; 10iŗLȌ
#define global DBL_EPSILON     0.00000000000000022204460492503131	; 1.0Ƃ̎ɑ傫lƂ̍
#const  global DBL_MANT_DIG    53									; bit
#define global DBL_MAX         double("1.7976931348623158e+308")	; ől
#const  global DBL_MAX_10_EXP  308									; 10ił̎w̍ől
#const  global DBL_MAX_EXP     1024									; 2ił̎w̍ől
#define global DBL_MIN         double("2.2250738585072014e-308")	; 0𒴂ŏ̒l
#const  global DBL_MIN_10_EXP  (-307)								; 10ił̎w̍ŏl
#const  global DBL_MIN_EXP     (-1021)								; 2ił̎w̍ŏl

// int ̌x
#const  global INT_DIGIT       32									; 2iŗLȌ
#const  global INT_DIGIT10     9									; 10iŗLȌ
#const  global INT_MAX         2147483647							; ől
#const  global INT_MIN         (-INT_MAX - 1)						; ŏl

#ifndef rad2deg
 #define global ctype rad2deg(%1) (57.295779513082320877   * (%1))	; WAxɕϊ
 #define global ctype deg2rad(%1) (0.017453292519943295769 * (%1))	; xWAɕϊ
#endif

#define global ctype pow(%1,%2) expf(logf(%1) * (%2))		; x^y
#define global ctype log10(%1) (logf(%1) / logf(10))		; log_10(x)
#define global ctype log2(%1)  (logf(%1) / logf(2))			; log_2(x)

#define global ctype roundf(%1) double(strf("%%0.0f", %1))	// ľܓ
#define global ctype root(%1,%2) expf(logf(%1) / (%2))		// ݏ捪 ( p )

//------------------------------------------------
// 
//------------------------------------------------
#defcfunc IsFinite double x
	return ( (x * 0) == 0 )
	
#defcfunc IsNaN double x
	return (x != x)
	
//------------------------------------------------
// oȐ֐
//------------------------------------------------
#defcfunc sinh double x
	return ( expf(x) - expf(-x) ) / 2
	
#defcfunc cosh double x
	return ( expf(x) + expf(-x) ) / 2
	
#defcfunc tanh double x
	return sinh(x) / cosh(x)
	
//------------------------------------------------
// t oȐ֐
//------------------------------------------------
#defcfunc asinh double x
	return logf( sqrt(x * x + 1.0) + x )
	
#defcfunc acosh double x
	return logf(sqrt(x * x - 1.0) + x)
	
#defcfunc atanh double x
	return logf((1.0 + x) / (1.0 - x)) / 2.0
	
//------------------------------------------------
// sin, cos ̋t֐
//------------------------------------------------
#defcfunc asin double x
	return atan(x, sqrt(1.0 - x * x))
	
#defcfunc acos double x
	return atan( sqrt(1.0 - x * x), x )
	
//------------------------------------------------
// Ίp
//
// @ __ (x, y) ܂ňL̕Ίp
// @	 (x, y) = (0, 0) ̂Ƃ 0.0
// @result: double [rad], l [0, 2)
//------------------------------------------------
#defcfunc argof double x, double y
	switch ( sgn(x) )		// x ̕ŕ
		case  0:
			switch ( sgn(y) )	// y ̕ŕ
				case 0:  return 0.0				// E: 0
				case  1: return M_PI / 2		// : (1/2)
				case -1: return M_PI * 1.5		// : (3/2)
			swend
		case  1: return atan( y, x )
		case -1: return atan( y, -x ) + M_PI
	swend
	return
	
//------------------------------------------------
// 
//------------------------------------------------
#defcfunc sgn double x
	return (x > 0) - (x < 0)
	
//------------------------------------------------
// ۂߊ֐
//------------------------------------------------
// ľܓ (: -0.5 = -1)
#defcfunc round double x
	if ( absf(x \ 1) >= 0.5 ) {
		return int(x) + sgn(x)
	} else {
		return int(x)
	}
	
	; roundf

//  (؂藎Ƃ)
#defcfunc intf double x
	return round( (-0.5) * sgn(x) + x )
	
// 
#defcfunc floor double x
	return round(x - 0.5)
	
#defcfunc floorf double x
	return intf(x) - ( x < intf(x) )
	
// 
#defcfunc ceil double x
	return - floor(- x)
	
#defcfunc ceilf double x
	return - floorf(- x)
	
//------------------------------------------------
// ̏]Z
//------------------------------------------------
#defcfunc fmod double p1, double p2
	return p1 \ p2		; p1 - ( p2 * intf(p1 / p2) )
	
//------------------------------------------------
// ^ϊ
//------------------------------------------------
#define global ctype IsDoubleIntNear(%1, %2 = 1e-14) ( absf((%1) - round(%1)) <= (%2) )
#defcfunc toIntIfNear double x
	if ( IsDoubleIntNear(x) ) {
		return round(x)
	} else {
		return x
	}
	
#defcfunc  IsDoubleInt double x
	return (x == round(x))
	
#defcfunc toIntIfCan double x
	if ( IsDoubleInt(x) ) {
		return round(x)
	} else {
		return x
	}
	
//------------------------------------------------
// ݏ
//------------------------------------------------
/*
#define global ctype powf_impl(%1, %2) expf(logf(%1) * (%2))
#undef powf
#defcfunc powf double p1, double p2
	if ( p1 < 0 ) {
		if ( p2 == int(p2) ) {
			return powf_impl(-p1, p2)
		} else {
			return logf(-1)	// NaN
		}
	} else {
		return powf_impl(p1, p2)
	}
//*/
	
//------------------------------------------------
// Op֐
//------------------------------------------------
/*
#define global ctype csc(%1) (1.0 / sin(%1))
#define global ctype sec(%1) (1.0 / cos(%1))
#define global ctype cot(%1) (1.0 / tan(%1))
#define global cosec csc
//*/

//------------------------------------------------
// 召֌W
//------------------------------------------------
#define global ctype max(%1,%2) ( (%1) * ((%1) >= (%2)) || (%2) * ((%1) < (%2)) )
#define global ctype min(%1,%2) ( (%1) * ((%1) <= (%2)) || (%2) * ((%1) > (%2)) )

#define ctype FTM_MAX_MIN_CODE(%1) \
	if ( p1 %1 p2 ) {	:\
		return p2		:\
	} else {			:\
		return p1		:\
	}

#defcfunc max_f double p1, double p2
	FTM_MAX_MIN_CODE(<)
	
#defcfunc min_f double p1, double p2
	FTM_MAX_MIN_CODE(>)
	
#defcfunc max_i int p1, int p2
	FTM_MAX_MIN_CODE(<)
	
#defcfunc min_i int p1, int p2
	FTM_MAX_MIN_CODE(>)

#undef FTM_MAX_MIN_CODE

//------------------------------------------------
// 񐔂̍
//------------------------------------------------
#define global ctype reminder(%1,%2) ( max((%1), (%2)) - min((%1), (%2)) )

#define ctype FTM_REMINDER_CODE(%1) \
	return %1(p1 - p2)
	
#defcfunc reminder_f double p1, double p2
	FTM_REMINDER_CODE(absf)
	
#defcfunc reminder_i int p1, int p2
	FTM_REMINDER_CODE(abs)

#undef FTM_REMINDER_CODE

//------------------------------------------------
// K(factorial)
//------------------------------------------------
#define ctype FTM_FACT_CODE(%1=1,%2=abs,%3=fact_i) \
	if ( int(p1) == 0 ) { return %1 }	/* 0 ̏ꍇ */:\
							:\
	ret = %1				:\
							:\
	repeat %2(p1), 1		:\
		ret *= cnt	/* Ђ|킹 */:\
	loop					:\
							:\
	return ret				;

;	if ( int(p1) <= 0 ) { return %1 }	/* 0 ̏ꍇ */:\
;	return p1 * %3(p1 - 1)
	
#defcfunc fact_f double p1,  local ret
	FTM_FACT_CODE(1.0, absf, fact_f)
	
#defcfunc fact_i int p1,  local ret
	FTM_FACT_CODE(1, abs, fact_i)
	
#undef FTM_FACT_CODE

//------------------------------------------------
// a(sum)
//------------------------------------------------
#define global ctype sum(%1,%2) ( ((%1) + (%2)) * (reminder((%1), (%2)) + 1) / 2 )

#define ctype FTM_SUM_CODE(%1) \
	return ( ( p1 + p2 ) * ( %1(p1, p2) + 1 ) / 2 )
	
#defcfunc sum_f double p1, double p2
	FTM_SUM_CODE(reminder_f)
	
#defcfunc sum_i int p1, int p2
	FTM_SUM_CODE(reminder_i)
	
#undef FTM_SUM_CODE

//------------------------------------------------
// (product)
// 
// @ ZŁAW̗vfׂĊ|킹鉉Z
// @ p1 ` p2 ̒lׂĊ|킹B
//------------------------------------------------
#defcfunc product_i int p1, int p2,  local result, local lesser, local greater, local i
	greater = max_i(p1, p2)
	lesser  = min_i(p1, p2)
	result  = 1.0
	for i, lesser, greater, 1
		result *= i
	next
	result *= greater
	return result
	
;	return fact_f(greater) / fact_f(lesser - 1)
	
//------------------------------------------------
//		[ ݏ ]
//	pow_f(p1, p2)
//
//	double p1 = 0 `	: l
//  int    p2 = 0 `	: w
//
//@p1  p2 ߂
// @ oCi@
//------------------------------------------------
#define ctype FTM_POW_CODE(%1=1)	\
	n = abs(p2)						:\
	v = %1							:\
	p = p1							:\
	repeat							:\
		if ( n == 0 ) { break }		:\
		if ( n & 1 ) {				:\
			v *= p					:\
		}							:\
		p  *= p						:\
		n >>= 1	/* ɂ */	:\
	loop							:\
	if ( p2 < 0 ) {					:\
		return %1 / v				:\
	}								:\
	return v
		
#defcfunc pow_f double p1, int p2,  local n, local v, local p
	FTM_POW_CODE(1.0)
	
#defcfunc pow_i int p1, int p2,  local n, local v, local p
	FTM_POW_CODE(1)
	
#define global inv   pow_f
#define global inv_f pow_f

#undef FTM_POW_CODE

//------------------------------------------------
//		[  ]
//	permutation(p1, p2)
//
//	int p1 = 0 `	: 
//  int p2 = 0 `	: 
//
//@p1  p2 Ƃ鏇̐߂
//	@ ߂l double
//------------------------------------------------
#defcfunc permutation int p1, int p2
	return fact_f(p1) / fact_f(p1 - p2)
	
//------------------------------------------------
//		[ g ]
//	combination(p1, p2)
//
//	int  p1 = 0 `	: 
//  int  p2 = 0 `	: 
//  bool p3 = bool	: dǂ
//
//@p1  p2 Ƃg̐߂
//	@ ߂l double
//------------------------------------------------
#defcfunc combination int p1, int p2, int p3
	if ( p3 == 0 ) {
		// p1 C p2
		return permutation(p1, p2) / fact_f(p2)
	} else {
		// p1 H p2
		return fact_f(p1 + p2 - 1) / ( fact_f(p2) * fact_f(p1 - 1) )
	}
	
//------------------------------------------------
//		[ ϊ ]
//	ChangeRadix( p1, p2, p3 )
//
// (str) p1 = 0 `		: ϊ̐ (int ł)
// (int) p2 = 1 ` (10)	: ϊ̊
// (int) p3 = 1 ` (10) : ϊ̊
//
//@w肵()̊ςB
//------------------------------------------------
#define global ctype ChangeRadix(%1,%2=10,%3=10,%4=0) _ChangeRadix(str(%1),%2,%3)
#defcfunc _ChangeRadix str p1, int p2, int radix,  local sRet, local c, local stmp, local len, local ten
	if ( p2 <= 0 || radix <= 0 ) { return -1 }		//  0 ͋֎~( 2 ` 31 ]܂ )
	if ( p2 == radix ) { return p1 }				// ꍇAςKv͂Ȃ
	
	// ɂ
	sdim sRet, 64
		 sRet = getpath(p1, 16)
	
	len = strlen(sRet)
	
	// \iɒ
	dim ten, 1
	if ( p2 == 10 ) {		// 10 
		ten = int( sRet )	// Kv͂Ȃ
		
	} else {
		repeat len
			c = peek(sRet, len - (cnt + 1))
			// 'a' ȏォʏ̐ '0' ŐľߕႤ
			ten += cwhich_int(c >= 'a', c - 'a' + 10, c - '0') * int(pow_f(p2, cnt))	// d݂|
		loop
	}
	
	memset sRet, 0, len
	if ( radix == 1 ) {						// i 1 ̗
		sdim   sRet, ten + 2
		memset sRet, '1', ten
		return sRet
	}
	
	if ( radix == 10 ) { return str(ten) }	// ͂o
	
	// ̊ɕϊ
	sdim stmp, len + 1
	repeat
		c = ten \ radix					// ܂擾
		if ( c >= 10 ) {				// 10ȏ̏ꍇ
			poke stmp, cnt, ('A' + c - 10)	// At@xbg
		} else {						// 0 ` 10 Ȃ
			poke stmp, cnt, c + '0'		// ܂肪ɓ
		}
		ten /= radix					// gČvZ
		if ( ten == 0 ) { break }		// ȂȂƏI
;		await 0
	loop
	
	len = strlen(stmp)
	sdim sRet, len * 2 + 1
	repeat len
		poke sRet, len - cnt - 1, peek(stmp, cnt)
	loop
	
	return sRet
	
//------------------------------------------------
//		[ ő ]
//	gcd(int p1, int p2)	
//
//		[ ŏ{ ]
//	lcm(int p1, int p2)
//
//	ǂ p1, p2 = 1 ` Fl
//
//------------------------------------------------
#define ctype FTM_GCD_CODE(%1,%2,%3=-1,%4=gcd_i) /* ő */:\
	if ( p1 == 0 && p2 == 0 ) { return (%3) }	/* p[^ȂƁu0ŏZvG[ɂȂ̂œP */:\
	if ( p1 == p2 )           { return p1 }		/* ȂA͂ǂƂɓ */:\
	if ( p1 ==  0 )           { return p2 }		/* ǂ炩0ȂA͂ɓB */:\
	if ( p2 ==  0 )           { return p1 }		/*  */:\
	return %4( p2, p1 \ p2 )					;
	
#define ctype FTM_LCM_CODE(%1,%2,%3=-1,%4=gcd_i) /* ŏ{ */:\
	if ( p1 ==  0 && p2 == 0 ) { return (%3) }	/* ǂ 0 Ȃ炷ɖ߂ */:\
	if ( p1 == p2 )            { return p1   }	/* ǂȂAl܂łȂA̐ */:\
	if ( p1 ==  0 || p2 == 0 ) { return (%3) }	/* ǂ 0 ȂAȂ */:\
	return ( p1 * p2 ) / %4( p1, p2 )			;
	
#defcfunc gcd_i int p1, int p2
	FTM_GCD_CODE(p1, p2, -1, gcd_i)
	
#defcfunc gcd_f double p1, double p2
	FTM_GCD_CODE(p1, p2, -1.0, gcd_f)
	
#defcfunc lcm_i int p1, int p2
	FTM_LCM_CODE(p1, p2, -1, gcd_i)
	
#defcfunc lcm_f double p1, double p2
	FTM_LCM_CODE(p1, p2, -1.0, gcd_f)
	
#undef FTM_GCD_CODE
#undef FTM_LCM_CODE

//------------------------------------------------
//------------------------------------------------

//------------------------------------------------
//------------------------------------------------

//------------------------------------------------
// ܂
// ꎟz̑
//------------------------------------------------
#define ctype FTM_ARRAY_ALL(%1) \
	foreach arr : %1 : loop		:\
	return result
	
// a
#defcfunc ArraySum array arr,  local result
	dimtype result, vartype(arr)
	FTM_ARRAY_ALL( result += arr(cnt) )
	
// 
#defcfunc ArrayProduct array arr,  local result
	dimtype result, vartype(arr)
	result += 1
	FTM_ARRAY_ALL( result *= arr(cnt) )
	
#undef FTM_ARRAY_ALL

#global

//##############################################################################
//                TvEXNvg
//##############################################################################

#if 0
	mes "Dmath.as"
	
	mes ChangeRadix("12437308CCB6", 16, 10)
	stop
	
#endif

#endif
