// Tree - ؍\

#ifndef IG_ABDATA_TREE_AS
#define IG_ABDATA_TREE_AS

#include "mod_pvalptr.as"
#include "mod_shiftArray.as"
#include "alg_iter.as"

/**+
 * abdata_tree
 * Abstract Data - Tree
 * @author Ue-dai
 * @date   2009/07/09
 * @ver    1.1.1
 * @type   ۃf[^^W[
 * @group  W[o֐
 */

//##############################################################################
//                m[hEW[
//##############################################################################
#module abdata_tree mValue, mName, mChildren, mIdParent, mcntChildren,  mIter_v, mIter_c

#define VAR_TEMP stt_temp@abdata_tree

#define ctype LOWORD(%1) ((%1) & 0xFFFF)
#define ctype HIWORD(%1) LOWORD((%1) >> 16)

#define global TNID_PARENT_OF_ROOT (0x7FFFFFFF)
#define global TNID_DISABLE        (0xFFFFFFFF)

#define mIter mIter_v(mIter_c)

#defcfunc TNode_toRegularName str _name,  local sName, local c
	sName = _name
	c     = peek(sName)
	if ( '0' <= c && c <= '9' ) {
		return "#"+ sName
	}
	return sName
	
/**
 * m[hId [g̐e
 * c[m[hId [gm[h̐em[h\lł邩ǂԂ܂B
 * Ȃΐ^l(0Ԃ)Aʏ̃m[h\ȂUl(0)Ԃ܂B
 * 
 * @return = void
 */
#defcfunc IsTnIdParentOfRoot int tnId
	return ( tnId == TNID_PARENT_OF_ROOT )
	
/**
 * m[hId L
 * c[m[hId Lȃm[h\lł邩ǂԂ܂B
 * Ȃΐ^l(0ȊO)ԂAȒlȂUl(0)Ԃ܂B
 * 
 * @return = void
 */
#defcfunc IsTnIdValid int tnId
	if ( tnId <= 0 || length(stt_allInsts) <= tnId ) {
		return false
	}
	return varuse(stt_allInsts(tnId))
	
/*;*
 * abdata_tree ̃CX^X𓾂
 * m[hId Ac[m[h̃CX^X擾܂B
 * 
 * @prm p1 = var    : c[m[h̃N[ɂϐ
 * @prm p2 = int    : c[m[hId
 * @return = void
 */
#deffunc TNode_getInstance var vResult, int tnId, int nIdx
	stt_TNInstance_var(nIdx) = stt_allInsts(tnId)
	return
	
/*;*
 * abdata_tree ̃CX^XԂ
 * m[hId Ac[m[h̃CX^X擾AԂ܂B
 * 
 * @prm p1 = int    : c[m[h Id
 * @return = modvar : CX^X
 */
#define global ctype TNInstance(%1,%2=0) stt_allInsts@abdata_tree(%1);stt_TNInstance_var@abdata_tree(TNInstance_core@abdata_tree(%1,%2))
#defcfunc local TNInstance_core int tnId, int nIdx
	TNode_getInstance stt_TNInstance_var, tnId, nIdx
	return nIdx
	
// m[hԂ
#modcfunc TNodeMod_getName
	return mName
	
// em[hId Ԃ
#modcfunc TNodeMod_getParent
	return midParent
	
// [gm[hId Ԃ
#modcfunc TNodeMod_getRoot  local node, local idParent
	node = thismod
	
	repeat
		idParent = TNodeMod_getParent(node)
		if ( IsTnIdParentOfRoot( idParent ) == false ) {
			break
		} else {
			TNode_getInstance node, idParent
		}
	loop
	return
	
// em[hIdύX
#modfunc TNodeMod_setParent int tnId
	midParent = tnId
	return
	
// qm[hIdǉ
#modfunc TNodeMod_addChildId int tnId
	mChildren( mcntChildren ) = tnId
	mcntChildren ++
	return mcntChildren - 1
	
// qm[h폜
#modfunc TNodeMod_removeChild int nIdx
	delmod TNInstance( mChildren(nIdx) )		// j
	
	ArrayRemove mChildren, nIdx
	mcntChildren --
	return
	
// qm[h̃CfbNX𓾂
#modcfunc TNodeMod_getChildIdx str _name,  local sName, local nIdx
	sName =  TNode_toRegularName(_name)
	nIdx  = -1
	
	// l
	if ( peek(sName) == '#' ) {
		getstr sName, sName, 1
		nIdx = int(sName)
		
		if ( nIdx < 0 || mcntChildren <= nIdx ) {		// qm[h͈̔͊Ołꍇ
			nIdx = -1
		}
		return nIdx
	}
	
	// 
	foreach mChildren
		if ( IsTnIdValid(mChildren(cnt)) == false ) { continue }
		if ( _name == TNodeMod_getName( TNInstance(mChildren(cnt)) ) ) {
			nIdx = cnt
			break
		}
	loop
	
	return nIdx
	
// qm[h݂͑邩ǂ
#modcfunc TNodeMod_existsChild str _name
	return TNodeMod_getChildIdx(thismod, _name) >= 0
	
// qm[h̃c[Id𓾂
#modcfunc TNodeMod_getChild str _name,  local nIdx
	nIdx = TNodeMod_getChildIdx(thismod, _name)
	if ( nIdx >= 0 ) {
		return mChildren(nIdx)
	}
	return TNID_DISABLE
	
/**
 * m[h̒lݒ肷
 * c[m[h̒lݒ肵܂B
 * lɂ́AǂȌ^łi[ł܂A
 * Zq = ŐɃRs[ł^łȂĂ͂Ȃ܂B
 * ( p2 ̒ĺAUAϐɃRs[܂ )
 * 
 * p2 ɕϐw肷ꍇ́ATNode_setv Ƃ邱Ƃł܂B
 * ϐnꍇ́AgpAʂȂIłB
 * 
 * @prm p1 = modvar	: W[ϐ
 * @prm p2 = any	: l
 * @return = void
 */
#define global TNode_set(%1,%2)  TNodeMod_set  TNInstance(%1), %2
#define global TNode_setv(%1,%2) TNodeMod_setv TNInstance(%1), %2

#define global TNodeMod_set(%1,%2) VAR_TEMP@abdata_tree = (%2) : TNodeMod_setv %1, VAR_TEMP@abdata_tree
#modfunc TNodeMod_setv var p2
	mValue = p2
	return
	
/**
 * [gm[h쐬
 * c[̈ԏɓA[gm[h쐬܂B
 * qm[h́ATNode_addChild ߂gpč쐬ĂB
 * m[h̒l͏l int ^ 0 łB
 * 
 * ̖߂ō쐬 p1 ́Aۂɂ struct ^ł͂܂񂪁A
 * @Node_* n̖߁E֐́AW[ϐ (modvar) ƂĎ󂯎܂B
 * @ȂAvaruse gpłȂAvartype  "int" ̒lԂAȂǂ̈Ⴂ܂B
 * 
 * @prm p1 = modvar       : m[hId 𓾂ϐ
 * @prm p2 = str ("root") : m[h
 * @return = int          : li[ p1 ̗vfԍ
 */
#define global TRoot_new(%1,%2="root") TNode_new %1, %2, TNID_PARENT_OF_ROOT
#define global TRootMod_new(%1="root") TNodeMod_new  %1, TNID_PARENT_OF_ROOT
#define global TNodeMod_new(%1,%2) newmod stt_allInsts@abdata_tree, abdata_tree@, %1, %2

#deffunc TNode_new array aryTnId, str _name, int parentId,  local id_new
	TNodeMod_new _name, parentId
	id_new = stat
	TNode_addNode aryTnId, id_new
	return stat
	
#deffunc TNode_addNode array aryTnId, int id_new,  local nIdx
	nIdx = -1
	
	// gĂȂvfT
	foreach aryTnId
		if ( IsTnIdValid( aryTnId(cnt) ) == false ) {
			nIdx = cnt
			break
		}
	loop
	
	if ( nIdx < 0 ) {
		nIdx = length(aryTnId)
	}
	
	aryTnId( nIdx ) = id_new
	return nIdx
	
#define global CreateTreeRoot TRoot_new
#define global CreateTreeNode TNode_new

/**
 * m[h̒l擾
 * c[m[h̒lAw肵ϐɃRs[܂B
 * ̒l֐̖߂lƂĐȏꍇ́A
 * TNode_get() ֐pĂ܂܂B
 * m[h̒ľ^́ATNode_getVarType() ֐Ŏ擾ł܂B
 * 
 * @prm p1 = modvar	: W[ϐ
 * @prm p2 = var	: 󂯎pϐ
 * @return = void
 */
#define global TNode_getv(%1,%2) TNodeMod_getv TNInstance(%1), %2
#modfunc TNodeMod_getv var p2
	p2 = mValue
	return
	
/**
 * m[h̒l擾
 * c[m[h̒lA֐`Ŏ擾܂B
 * m[h̒lgݍ݌^(double, int, str)̏ꍇɂ̂
 * gpĂB
 * 
 * @prm p1 = modvar	: W[ϐ
 * @return = any	: m[h̒l
 */
#define global ctype TNode_get(%1) TNodeMod_get(TNInstance(%1))
#modcfunc TNodeMod_get
	return mValue
	
/**
 * m[ȟ^擾
 * c[m[hێĂľ^Ԃ܂B
 * ԂĺAvartype() ֐Ԃ̂ƓłB
 * 
 * @prm p1 = modvar	: W[ϐ
 * @return = int	: ^^Cvl
 */
#define global ctype TNode_getValueType(%1) TNodeMod_getValueType( TNInstance(%1) )
#modcfunc TNodeMod_getValueType
	return vartype(mValue)
	
/**
 * qm[h̐擾
 * c[m[hLĂqm[h̐Ԃ܂B
 * 
 * m[hȍ~͖̐֌WłB
 * 
 * @prm p1 = modvar	: W[ϐ
 * @return = int	: qm[h̐
 * 
 * @ TNode_size(), TNode_count(), TNode_length() ƓB
 * @! ̐ length(mChildren) Ƃ͈Ⴄ̂Œ
 */
#define global ctype TNode_cntChildren(%1) TNodeMod_cntChildren( TNInstance(%1) )
#modcfunc TNodeMod_cntChildren
	return mcntChildren
	
#define global TNode_empty  TNode_cntChildren
#define global TNode_size   TNode_cntChildren
#define global TNode_count  TNode_cntChildren
#define global TNode_length TNode_cntChildren
	
/**
 * [gm[hł邩
 * [gm[hǂ𒲂ׂ܂B
 * 
 * @prm p1 = modvar	: W[ϐ
 * @return = bool	: [gm[hȂ^AłȂȂU
 */
#define global ctype TNode_isRoot(%1) TNodeMod_isRoot( TNInstance(%1) )
#modcfunc TNodeMod_isRoot
	return ( mIdParent == TNID_PARENT_OF_ROOT )
	
/**
 * em[hId𓾂
 * c[m[h̐eIdԂ܂B
 * [gm[hw肵ꍇ́AIDlԂ܂B
 * 
 * @prm p1 = modvar	: W[ϐ
 * @prm p2 = var	: N[ɂϐ
 * @return = void
 */
#define global ctype TNode_getParent(%1) TNodeMod_getParent( TNInstance(%1) )

/**
 * [gm[hId𓾂
 * ċAI TNode_getParent() pāÃc[̃[gm[h擾Am[hId 𓾂܂B
 * 
 * @prm p1 = modvar : W[ϐ
 * @return = int    : [gm[hId
 */
#defcfunc TNode_getRoot int _thisId,  local thisId
	thisId = _thisId
	
	repeat
		if ( TNode_isRoot( thisId ) ) { break }
		thisId = TNode_getParent( thisId )
	loop
	
	return thisId
	
/**
 * m[h擾
 * c[m[h̃m[hԂ܂B
 * m[h́Aqm[hIꍇɂ̂ݎgp܂B
 * 
 * @prm p1 = modvar	: W[ϐ
 * @return = str	: m[h
 */
#define global ctype TNode_getName(%1) TNodeMod_getName( TNInstance(%1) )

/**
 * qm[h()ǉ
 * p1 ɕ؂Aqm[hƂĒǉ܂B
 * ǉ p2  Root ꍇAʂɂ̂܂܌q܂B
 * Root Ŗꍇ́Aʂ̂A܂B
 * qm[h̃W[ϐ擾ɂ́A
 * TNode_getChild ߂gpĂB
 * 
 * @prm p1 = modvar	: em[h̃W[ϐ
 * @prm p2 = modvar : 
 * @return = int    : ǉqm[h̃m[hId
 */
#define global TNode_addSubTree(%1,%2) TNodeMod_addSubTree TNInstance(%1), %2, %1

#modfunc TNodeMod_addSubTree int subTreeId, int thisId,  local id_new, local srcId, local tmpNode
	if ( TNode_isRoot(subTreeId) ) {
		TNodeMod_setParent  TNInstance(subTreeId), thisId
		srcId = subTreeId
	} else {
		TRoot_new  tmpNode, TNode_getName(subTreeId)
		TNode_copy tmpNode, subTreeId
		srcId = tmpNode
		assert
	}
	
	TNode_addNode mChildren, srcId
	id_new = mChildren( stat )
	mcntChildren ++
	return id_new
	
/**
 * qm[hǉ
 * qm[hVK쐬Ap1 ɒǉ܂B
 * qm[h̃W[ϐ擾ɂ́A
 * TNode_getChild ߂gpĂB
 * 
 * @prm p1 = modvar	: em[h̃W[ϐ
 * @prm p2 = str	: m[h
 * @return = int    : 쐬qm[h̃m[hId
 */
#define global TNode_addChild(%1,%2) TNodeMod_addChild TNInstance(%1), %2, %1

#modfunc TNodeMod_addChild str _name, int thisId,  local id_new
	TNode_new mChildren, _name, thisId
	id_new =  mChildren( stat )
	mcntChildren ++
	return id_new
	
/**
 * qm[h݂̑m߂
 * w肵m[h̎qm[h݂邩ǂ𒲂ׂ܂B
 * ݂ꍇ͐^( 0 ȊO )Ԃ܂B
 * Ȃꍇ͋U( 0 )Ԃ܂B
 * 
 * ̊֐́uTNode_exist's'ChildvłB
 * exists  s Ȃ悤ɋCtĂB
 * 
 * @prm p1 = modvar	: em[h̃W[
 * @prm p2 = str	: m[h
 * @return bool		: ݂^
 */
#defcfunc TNode_existsChild int thisId, str _name
	return TNodeMod_existsChild( TNInstance(thisId), _name )
	
/**
 * qm[hId 𓾂
 * qm[hId Ԃ܂Bqm[h̓[gm[hƓ悤Ɏgpł܂B
 * 
 * sꍇ͕Ԃ܂B
 * 
 * ̖߂́ATNChild łpł܂AxQƂꍇA
 * XNvgȂ̂ȏꍇȂǂɎgpł܂B
 * 
 * @prm p1 = modvar	: em[h̃W[ϐ
 * @prm p2 = str	: qm[h
 * @return = int	: qm[hId
 */
#define global ctype TNode_getChild(%1,%2) TNodeMod_getChild( TNInstance(%1), str(%2) )

// Kw\Ή
#defcfunc TNode_getChildHier int _thisId, str _name,  local thisId, local sName, local stmp
	thisId = _thisId
	sName  = _name
	
	if ( peek(sName) == '/' ) {			// ΃pX
		getstr sName, sName, 1
		thisId = TNode_getRoot(thisId)	// [gm[h猟Jn
	}
	repeat
		if ( instr(sName, , "/") >= 0 ) {
			getstr  stmp, sName, 0, '/'
			getstr sName, sName, strsize
			thisId = TNode_getChildHier( thisId, stmp )
		} else {
			break
		}
	loop
	return TNode_getChild( thisId, sName )
	
/**
 * qm[h̃W[ϐ
 * w肵m[h̎qm[hԂ֐łB
 * ݂Ȃꍇ̓G[ɂȂ\̂ŁA
 * K TNode_existsChild() ֐ő݂m߂ĂĂB
 * 
 * ́AĂяoтɎqm[h邽߁AᑬłB
 * xĂяoꍇ́Ax TNode_getChild ߂
 * N[쐬ĂƂ𐄏܂B
 * 
 * ӁF̊֐͓qɂł܂B
 * @@@() TNChild( TNChild(m, "x"), "y" )
 * @@@Ή\łB
 * ӁF̊֐pĂ̍ċA͍s܂B
 * 
 * ۂɂ͊֐ł͂܂񂪁Ał͂܂B
 * 
 * @prm p1 = modvar	: em[h̃W[ϐ
 * @prm p2 = str	: m[h
 * @return modvar	: qm[h̃W[ϐ
 */
#define global ctype TNChild(%1,%2) stt_tnchild_var@abdata_tree(TNChild_core@abdata_tree(%1,%2))
#defcfunc TNChild_core@abdata_tree int thisId, str _name
	TNode_getInstance stt_tnchild_var, TNode_getChild( thisId, _name )		// N[ɂ
	return 0
	
// Kw\Ή ( ᑬ(1/2) )
#define global ctype TNChildHier(%1,%2) stt_tnchild_var@abdata_tree(TNChildHier_core@abdata_tree(%1,%2))
#defcfunc TNChildHier_core@abdata_tree int thisId, str _name
	TNode_getInstance stt_tnchild_var, TNode_getChildHier( thisId, _name )
	return 0
	
/**
 * em[h̃W[ϐ
 * w肵m[h̐em[h̃W[ϐԂ֐łB
 * 
 * ̊֐́ATNChild() Ƃ͈ႢA܂ᑬł͂܂B
 * 10x̎QƂȂATNode_getParent ȂĂ肠܂B
 * ( ܂ɎQƉ񐔂ꍇ͕ʂłB )
 * 
 * ӁF[gm[h̐e݂͑Ȃ̂ŁȀꍇ int ^ 0 ԂĂ܂B
 * 
 * @prm p1 = modvar	: W[ϐ ( [gm[hłȂ )
 * @return = modvar	: em[h̃W[ϐ
 */
#define global ctype TNParent(%1) stt_tnparent_var@abdata_tree( TNParent_core@abdata_tree(%1) )
#defcfunc TNParent_core@abdata_tree int thisId
	TNode_getInstance stt_tnparent_var, TNode_getParent( thisId )
	return 0
	
/**
 * m[hNA
 * c[m[h̒lA̎qm[hׂč폜܂B
 * 
 * @prm p1 = modvar	: W[ϐ
 * @return void
 */
#define global TNode_clear(%1) TNodeMod_clear TNInstance(%1)
#modfunc TNodeMod_clear
	// qm[h폜
	if ( mcntChildren ) {
		foreach mChildren
			if ( IsTnIdValid( mChildren(cnt) ) ) {
				TNode_clear mChildren(cnt)
				delmod thismod
			}
		loop
	}
	
	mValue       = 0
	mChildren    = TNID_DISABLE
	mcntChildren = 0
	mIter_v      = 0
	mIter_c      = -1
	
	return
	
/**
 * m[h폜
 * c[m[h폜܂B
 * 
 * ܂Ãm[h̎qm[hAׂč폜܂B
 * 폜ꂽm[h̃N[ɂȂ܂B
 * ȃN[gpȂ悤ɋCtĂB
 * 
 * @prm p1 = modvar	: W[ϐ
 * @return void
 */
#define global TNode_delete(%1) TNodeMod_delete TNInstance(%1)
#modfunc TNodeMod_delete
	TNode_clear thismod
	delmod      thismod
	return
	
/*
#modterm
	return
//*/

//##########################################################
//        q (iterator)
//##########################################################
#define global TNode_iterNew(%1) TNodeMod_iterNew TNInstance(%1)
#modfunc TNodeMod_iterNew
	if ( mIter_c < 0 ) {
		mIter_c = 0
	} else {
		mIter_c ++
	}
	
	mIter = -1
	return
	
#define global TNode_iterDelete(%1) TNodeMod_iterDelete TNInstance(%1)
#modfunc TNodeMod_iterDelete
	mIter_c --
	return
	
#modfunc TNodeMod_iterCheckCore var vIterId
	// qm[h
	if ( mIterMode == TRAVERSE_MODE_CHILDREN ) {
		mIter ++
		
		// ȏqm[h͂Ȃ
		if ( mIter >= mcntChildren ) {
		;	vIterId = TNID_DISABLE		// default  TNID_DISABLE Ȃ̂őKv͂Ȃ
			return
			
		// ܂qm[h
		} else {
			vIterId = mChildren(mIter)
			if ( IsTnIdValid(vIterId) == false ) {
				TNodeMod_iterCheckCore thismod, vIterId		// JԂ
			}
		}
	}
	return
	
#define global ctype TNode_iterCheck(%1,%2) TNodeMod_iterCheck(TNInstance(%1), %2)
#modcfunc TNodeMod_iterCheck var vIterId
	vIterId = TNID_DISABLE
	
	TNodeMod_iterCheckCore thismod, vIterId
	
	if ( vIterId == TNID_DISABLE ) {
		TNodeMod_iterDelete thismod
		return false
	}
	return true
	
//------------------------------------------------
// [i] q
//------------------------------------------------
#deffunc TNode_iterInit int thisId, var iterData
	TNode_iterNew thisId
	return
	
//------------------------------------------------
// [i] qXV
//------------------------------------------------
#defcfunc TNode_iterNext int thisId, var vIt, var iterData
	return TNode_iterCheck(thisId, vIt)
	
//##########################################################
//        ̑
//##########################################################
/**
 * m[hA
 * m[h̎qm[hׂĂċAIɕAǉ܂B
 * 
 * @prm p1 = modvar	: W[ϐ
 * @prm p2 = modvar	: A
 * @return = void
 */
#deffunc TNode_chain int thisId, int fromId,  local itId, local stmp, local childId, local value
	
	TNode_iterNew fromId
	while ( TNode_iterCheck(fromId, itId) )
		
		stmp = TNode_getName(itId)
		TNode_getv itId, value
		
		TNode_addChild thisId, stmp		// ̎qm[hǉ
		childId = stat
		TNode_setv  childId, value		// ێlRs[
		TNode_chain childId, itId		// xm[hA
		
	wend
	return
	
/**
 * m[h𕡐
 * m[h̒lƁA̎qm[hׂĂċAIɕ܂B
 * 
 * @prm p1 = modvar	: W[ϐ
 * @prm p2 = modvar	: 
 * @return = void
 */
#deffunc TNode_copy int thisId, int fromId
	TNode_clear thisId
	TNode_set   thisId, TNode_get(fromId)
	TNode_chain thisId, fromId
	return
	
/**
 * m[h
 * 2̃m[h܂B
 * 
 * @prm p1 = modvar : m[h1
 * @prm p2 = modvar : m[h2
 * @return = void
 */
#deffunc TNode_exchange int thisId, int fromId, local tempId
	TRoot_new  tempId
	TNode_copy tempId, thisId
	TNode_copy thisId, fromId
	TNode_copy fromId, tempId
	TNode_delete tempId
	return
	
//------------------------------------------------
// [i] RXgN^
//------------------------------------------------
#modinit str _name, int _idParent
	sdim mName				// m[h
	mIdParent = _idParent	// em[h
	mName     = _name
	
	TNodeMod_clear thismod
	return getaptr(thismod)
	
//##########################################################
//        fobOpo
//##########################################################
#ifdef _DEBUG
//-------- fobO --------

//------------------------------------------------
// m[hċAIɏo͂
//------------------------------------------------
#deffunc TNode_dbglog int _thisId, int nest,  local thisId, local itId, local stmp
	thisId = _thisId
	if ( isTnIdValid(thisId) == false ) { return }
	
	sdim stmp, nest * 2 + 512
	
	if ( nest > 0 ) {
		repeat nest - 1
			stmp += "|  "
		loop
	}
	if ( TNode_isRoot(thisId) == false ) {
		stmp += "|-- "
	}
	
	logmes stmp + TNode_getName( thisId )
	
	TNode_iterNew thisId
	while ( TNode_iterCheck( thisId, itId ) )
		TNode_dbglog itId, nest + 1
	wend
;	IterateBegin thisId, TNode, itId
;		TNode_dbglog itId, nest + 1
;	IterateEnd
	
	return
	
#else
//-------- fobO --------

#define TNode_dbglog(%1,%2) :

#endif

#global
TRootMod_new ""

//##############################################################################
//               TvEXNvg
//##############################################################################
#if 1
	
	TRoot_new tr
	TNode_set tr, "e"
	
	for i, 0, 3
		name = "c"+ i
		TNode_addChild tr, name
		TNode_set stat, TNode_get(tr) +" - q("+ i +")"
		
		repeat 5
			name = "cc"+ cnt
			
			child = TNode_getChild( tr, "c"+ i )
			
			TNode_addChild child, name
			TNode_set stat, TNode_get(child) +" - ("+ cnt +")"
		loop
		
	next
	
	for i, 0,  TNode_cntChildren( tr )
		repeat TNode_cntChildren( TNChild(tr, "c"+ i) )
			mes TNode_get( TNChild( TNChild(tr, "c"+ i), "cc"+ cnt) )
;			mes TNode_get( TNChildHier( mtr, "c"+ i +"/cc"+ cnt ) )		// '/' ŊKw\
		loop
	next
	
	pos 300, 10
	TNode_dbglog tr
	
	TRoot_new    tr2, "root2"
	TNode_chain  tr2, tr
;	TNode_copy   tr2, tr
	TNode_dbglog tr2
	
	TNode_addSubTree tr, tr2
	TNode_dbglog tr
	
	logmes ""
	assert
	TNode_addSubTree tr, tr2
	TNode_dbglog tr
	
	stop

#endif

#endif
