// Klac - debug

#ifndef IG_MODULE_KLAC_DEBUG_AS
#define IG_MODULE_KLAC_DEBUG_AS

#ifndef _DEBUG_____		// ! Release gƂɂ

#include "Mo/abdata/queue.as"
#include "Mo/abdata/stack.as"
#include "Mo/abdata/pair.as"
#include "Mo/Dmath.as"

#include "MCEnv.as"
#include "MCVar.as"
#include "MCFunc.as"
#include "MCBlock.as"
#include "MCAssoc.as"

#module mod_Klac_debug

#include "header_inner.as"

//##########################################################
//        񋓒萔  
//##########################################################
//------------------------------------------------
// G[^Cv
//------------------------------------------------
#defcfunc EnumString_Error int val
	switch ( val )
		case Error_Msg:          return "Error_Msg"
		case Error_Syntax:       return "Error_Syntax"
		case Error_Bracket:      return "Error_Bracket"
		case Error_DivBy0:       return "Error_DivBy0"
		case Error_Infinity:     return "Error_Infinity"
		
	;	case Error_NeedValtype:  return "Error_NeedValtype"
		case Error_NeedError:    return "Error_NeedError"
		case Error_NeedIdent:    return "Error_NeedIdent"
		case Error_NeedVar:      return "Error_NeedVar"
		case Error_NeedBool:     return "Error_NeedBool"
		case Error_NeedInt:      return "Error_NeedInt"
		case Error_NeedDouble:   return "Error_NeedDouble"
		case Error_NeedString:   return "Error_NeedString"
		case Error_NeedAssoc:    return "Error_NeedAssoc"
		case Error_NeedBlock:    return "Error_NeedBlock"
		case Error_NeedFunc:     return "Error_NeedFunc"
		case Error_NeedMethod:   return "Error_NeedMethod"
		case Error_NeedPropaty:  return "Error_NeedPropaty"
	;	case Error_NeedValtype_Max:
		
		case Error_NeedLeftValue:  return "Error_NeedLeftValue"
		case Error_NeedPair:       return "Error_NeedPair"
		case Error_NeedVector:     return "Error_NeedVector"
		case Error_NeedCallable:   return "Error_NeedCallable"
		case Error_NeedIndexable:  return "Error_NeedIndexable"
		case Error_NoResult:       return "Error_NoResult"
		case Error_UnknownResult:  return "Error_UnknownResult"
		case Error_NotMember:      return "Error_NotMember"
		case Error_InvalidIndex:   return "Error_InvalidIndex"
		case Error_Argc:           return "Error_Argc"
		case Error_InvalidValue:   return "Error_InvalidValue"
		case Error_NoDefault:      return "Error_NoDefault"
		case Error_UnSupported:    return "Error_UnSupported"
	;	case Error_Max:
		default:
			assert
	swend
	
//------------------------------------------------
// I[h
//------------------------------------------------
#defcfunc EnumString_ExitMode int val
	switch ( val )
		case ExitMode_Normal:   return "ExitMode_Normal"	// ʏI
		case ExitMode_Return:   return "ExitMode_Return"	// return
		case ExitMode_Yield:    return "ExitMode_Yield"		// yield
		case ExitMode_Break:    return "ExitMode_Break"		// break
		case ExitMode_Continue: return "ExitMode_Continue"	// continue ()
		case ExitMode_Throw:    return "ExitMode_Throw"		// throw ()
	swend
	assert
	
//------------------------------------------------
// l̃^Cv
// 
// @synchronizing:
// @	Valtype [*]
// @	ERROR   [_NeedValtype, _NeedValtypeMax]
//------------------------------------------------
#defcfunc EnumString_Valtype int val
	switch ( val )
		case Valtype_Error:   return "Valtype_Error"
		case Valtype_Ident:   return "Valtype_Ident"
		case Valtype_Var:     return "Valtype_Var"
		case Valtype_Bool:    return "Valtype_Bool"
		case Valtype_Int:     return "Valtype_Int"
		case Valtype_Double:  return "Valtype_Double"
		case Valtype_String:  return "Valtype_String"
		case Valtype_Assoc:   return "Valtype_Assoc"
		case Valtype_Block:   return "Valtype_Block"
		case Valtype_Func:    return "Valtype_Func"
		case Valtype_Method:  return "Valtype_Method"
		case Valtype_Propaty: return "Valtype_Propaty"
		
		case Valtype_RefArg:  return "Valtype_RefArg"
		case Valtype_Arglist: return "Valtype_Arglist"
		
		case Valtype_Mark:    return "Valtype_Mark"
		case Valtype_OpUni:   return "Valtype_OpUni"
		case Valtype_OpBin:   return "Valtype_OpBin"
		
		case Valtype_Decoded: return "Valtype_Decoded"
	;	case Valtype_MAX:
		default:
			assert
	swend
	
#defcfunc GetName_Valtype int val,  local tmp
	tmp = EnumString_Valtype(val)
	getstr tmp, tmp, 8
	return tmp
	
//------------------------------------------------
// g[N̎
//------------------------------------------------
#defcfunc EnumString_TkType int val
	switch ( val )
		case TkType_Error:     return "TkType_Error"		// G[
		case TkType_None:      return "TkType_None"			// JnEI[L
		case TkType_Int:       return "TkType_Int"			// l
		case TkType_Double:    return "TkType_Double"		// l
		case TkType_String:    return "TkType_String"		// 
		case TkType_StrBlock:  return "TkType_StrBlock"		// 򕶎
		case TkType_Ident:     return "TkType_Ident"		// ʎq
		case TkType_PrefixOp:  return "TkType_PrefixOp"		// PZq::Ou(prefix)
		case TkType_PostfixOp: return "TkType_PostfixOp"	// PZq::u(postfix)
		case TkType_BinOp:     return "TkType_BinOp"		// 񍀉Zq
		case TkType_PolyOp_Tuple:return "TkType_PolyOp_Tuple"	// Zq ,
		
		case TkType_ParenL:  return "TkType_ParenL"			// ۊ::
		case TkType_ParenR:  return "TkType_ParenR"			// ۊ::E
		case TkType_ArgL:    return "TkType_ArgL"			// ::
		case TkType_ArgR:    return "TkType_ArgR"			// ::E
		case TkType_BlockL:  return "TkType_BlockL"			// 򊇌:: "{"
		case TkType_BlockR:  return "TkType_BlockR"			// 򊇌::E "}"
		case TkType_ArrayL:  return "TkType_ArrayL"			// 򊇌:: "["
		case TkType_ArrayR:  return "TkType_ArrayR"			// 򊇌::E "]"
		case TkType_IndexL:  return "TkType_IndexL"			// Y:: "["
		case TkType_IndexR:  return "TkType_IndexR"			// Y::E "]"
		case TkType_TupleL:  return "TkType_TupleL"			// l::
		case TkType_TupleR:  return "TkType_TupleR"			// l::E
		case TkType_Comma:   return "TkType_Comma"			// J}
		case TkType_Declare: return "TkType_Declare"		// 錾
		
		case TkType_Blank:    return "TkType_Blank"			// 
		case TkType_Operator: return "TkType_Operator"		// Zq
		case TkType_Omission: return "TkType_Omission"		// ȗ (֐̈)
	;	case TkType_Max:
		default:
			assert
	swend
	
//------------------------------------------------
// PZq::Ou
//------------------------------------------------
#defcfunc EnumString_PrefixOp int val
	switch ( val )
		case PrefixOp_Plus:  return "PrefixOp_Plus"		// +
		case PrefixOp_Minus: return "PrefixOp_Minus"	// -
		case PrefixOp_Inv:   return "PrefixOp_Inv"		// /
		case PrefixOp_Exp:   return "PrefixOp_Exp"		// ^
		case PrefixOp_Sqrt:  return "PrefixOp_Sqrt"		// //
		case PrefixOp_Not:   return "PrefixOp_Not"		// ~
		case PrefixOp_Neg:   return "PrefixOp_Neg"		// !
		case PrefixOp_Func:  return "PrefixOp_Func"		// =>
		case PrefixOp_Inc:   return "PrefixOp_Inc"		// ++
		case PrefixOp_Dec:   return "PrefixOp_Dec"		// --
	;	case PrefixOp_Max:
		default:
			assert
	swend
	
//------------------------------------------------
// PZq::u
//------------------------------------------------
#defcfunc EnumString_PostfixOp int val
	switch ( val )
		case PostfixOp_Fact:    return "PostfixOp_Fact"		// !
		case PostfixOp_Percent: return "PostfixOp_Percent"	// %
		case PostfixOp_Inc:     return "PostfixOp_Inc"		// ++
		case PostfixOp_Dec:     return "PostfixOp_Dec"		// --
		case PostfixOp_Tuple:   return "PostfixOp_Tuple"	// ,
		case PostfixOp_Snake:   return "PostfixOp_Snake"	// ;
		case PostfixOp_Call:    return "PostfixOp_Call"		// ()
		case PostfixOp_Index:   return "PostfixOp_Index"	// []
	;	case PostfixOp_Max:
		default:
			assert
	swend
	
#defcfunc GetName_UniOp int val,  local tmp
	if ( EnumRange_UniOp_Prefix(val) ) {	// Ou(Prefix)
		tmp = EnumString_PrefixOp(val)
		getstr tmp, tmp, 9
	} else {								// u(Postfix)
		tmp = EnumString_PostfixOp(val)
		getstr tmp, tmp, 10
	}
	return tmp
	
//------------------------------------------------
// 񍀉Zq::u
//------------------------------------------------
#defcfunc EnumString_BinOp int val
	switch ( val )
		case BinOp_Split:  return "BinOp_Split"		// ;
		
		case BinOp_Set:    return "BinOp_Set"		// :=
		case BinOp_Swap:   return "BinOp_Swap"		// <->
		
		case BinOp_Tuple:  return "BinOp_Tuple"		// ,
		
		case BinOp_Pair:   return "BinOp_Pair"		// :
		case BinOp_Which:  return "BinOp_Which"		// ?
		case BinOp_NullOr: return "BinOp_NullOr"	// ??
		
		case BinOp_Lambda: return "BinOp_Lambda"	// =>
		
		case BinOp_LogImp: return "BinOp_LogImp"	// -->
		case BinOp_LogOr:  return "BinOp_LogOr"		// ||
		case BinOp_LogXor: return "BinOp_LogXor"	// ~~
		case BinOp_LogAnd: return "BinOp_LogAnd"	// &&
		
		case BinOp_EqRf:   return "BinOp_EqRf"		// ===
		case BinOp_NeRf:   return "BinOp_NeRf"		// !==
		case BinOp_Eq:     return "BinOp_Eq"		// ==
		case BinOp_Ne:     return "BinOp_Ne"		// !=
		case BinOp_Lt:     return "BinOp_Lt"		// <
		case BinOp_Gt:     return "BinOp_Gt"		// >
		case BinOp_LtEQ:   return "BinOp_LtEQ"		// <=
		case BinOp_GtEQ:   return "BinOp_GtEQ"		// >=
		case BinOp_Cmp:    return "BinOp_Cmp"		// <>
		case BinOp_Belong: return "BinOp_Belong"	// <:
		
		case BinOp_ShiftL: return "BinOp_ShiftL"	// <<
		case BinOp_ShiftR: return "BinOp_ShiftR"	// >>
		case BinOp_BitOr:  return "BinOp_BitOr"		// |
		case BinOp_BitXor: return "BinOp_BitXor"	// ~
		case BinOp_BitAnd: return "BinOp_BitAnd"	// &
		
		case BinOp_Add:    return "BinOp_Add"		// +
		case BinOp_Sub:    return "BinOp_Sub"		// -
		case BinOp_Mul:    return "BinOp_Mul"		// *
		case BinOp_Div:    return "BinOp_Div"		// /
		case BinOp_Mod:    return "BinOp_Mod"		// %
		
		case BinOp_Trans:  return "BinOp_Trans"		// +> (ϊ)
		case BinOp_Pow:    return "BinOp_Pow"		// ^  (p)
		case BinOp_Root:   return "BinOp_Root"		// // (p)
		
		case BinOp_Assoc:     return "BinOp_Assoc"		// .
		case BinOp_AssocBind: return "BinOp_AssocBind"	// ->
		
	;	case BinOp_Max:
		default:
			assert
	swend
	
#defcfunc GetName_BinOp int val,  local tmp
	tmp = EnumString_BinOp(val)
	getstr tmp, tmp, 6
	return tmp
	
#defcfunc GetName_Operator int val,  local tmp
	if ( val < PostfixOp_Max ) {
		return GetName_UniOp(val)
	} else {
		return GetName_BinOp(val)
	}
	
//------------------------------------------------
// gݍ݊֐ID
//------------------------------------------------
#defcfunc EnumString_Func int iFunc
	return func_GetName( iFunc )
	
//------------------------------------------------
// gݍݕϐID
//------------------------------------------------
#defcfunc EnumString_Var int iVar
	return var_GetName( iVar )
	
//##########################################################
//        vf̕
//##########################################################
//------------------------------------------------
// vf  
//------------------------------------------------
#defcfunc DecodeToken int tktype, var value
	switch ( tktype )
		case TkType_Error:      return "(Error: " + value + ")"		// G[
		case TkType_None:       return "(JnL)"					// JnEI[L
		
		case TkType_Ident:      return str(value)					// ʎq
		case TkType_Int:        									// l
		case TkType_Double:     return value						// l
		case TkType_String:     return "<\"" + value + "\">"		// 
		case TkType_StrBlock:   return "{ " + value + " }"			// 򕶎
		
		case TkType_PrefixOp:
		case TkType_PostfixOp:  return DecodeOp_Uni(int(value))		// PZq::Ou(prefix), u(postfix)
		case TkType_BinOp:      return DecodeOp_Bin(int(value))		// 񍀉Zq
		case TkType_PolyOp_Tuple:return ",<" + value + ">"
		
		case TkType_ParenL:     return "("						// ۊ::
		case TkType_ParenR:     return ")"						// ۊ::E
		case TkType_ArgL:       return "("						// ::
		case TkType_ArgR:       return ")"						// ::E
		case TkType_BlockL:     return "{"						// ̈抇:: "{"
		case TkType_BlockR:     return "}"						// ̈抇::E "}"
		case TkType_ArrayL:     return "["						// 򊇌:: "["
		case TkType_ArrayR:     return "]"						// 򊇌::E "]"
		case TkType_IndexL:     return "["						// Y:: "["
		case TkType_IndexR:     return "]"						// Y::E "]"
		case TkType_TupleL:     return "("						// l::
		case TkType_TupleR:     return ")"						// l::E
		case TkType_Comma:      return ","						// J}
		
		case TkType_Blank:      return " "						// 
		case TkType_Operator:   return "(TkType_Operator: " + value + ")"		// Zq
		case TkType_Omission:   return "omission"				// ȗ (֐̈)
	;	case TkType_Max:
		default:
			assert
	swend
	return
	
//------------------------------------------------
// Zvf  
//------------------------------------------------
#defcfunc DecodeEvalElem int valtype, var value
	if ( sublev >= 128 || looplev >= 30 ) { return "(error: zQƋ^f)" }
	
	switch ( valtype )
		case Valtype_Error:     return "#(error)# Dev.putError( " + value + " )"
		case Valtype_Ident:     return value
		case Valtype_Var:       return DecodeValue_Var(value)
		case Valtype_Bool:      return DecodeValue_Bool(value)
		case Valtype_Int:       return DecodeValue_Int(value)
		case Valtype_Double:    return DecodeValue_Double(value)
		case Valtype_String:    return "<\"" + value + "\">"
		case Valtype_Assoc:     return DecodeValue_Assoc(value)
		case Valtype_Block:     return DecodeValue_Block(value)
		case Valtype_Func:      return DecodeValue_Func( FuncId(value) )
		case Valtype_Method:    return DecodeValue_Method(value)
		case Valtype_Propaty:   return DecodeValue_Propaty(value)
		
		case Valtype_Mark:
			if ( value == TkType_Omission ) { return "omission" }		// ȗ
			return "Valtype_Mark"
			
		case Valtype_OpUni:     return "Valtype_OpUni"
		case Valtype_OpBin:     return "Valtype_OpBin"
		case Valtype_RefArg:    return DecodeValue_RefArg( value )
		
		case Valtype_Decoded:   return "Valtype_Decoded( " + value + " )
	;	case Varlype_MAX:
		default:
			assert
	swend
	return
	
//##########################################################
//        l̕
//##########################################################
#define StrIndentEachLine(%1) StrReplace (%1), "\n", "\n\t"

//------------------------------------------------
// ϐ
// 
// @prm bPair: Ό`(name: value)ŏo
//------------------------------------------------
#defcfunc DecodeValue_Var int iVar, int bPair,  local name, local type, local value, local body
	name = var_GetName(iVar)
	if ( bPair ) {
		body = name + ": " + DecodeValue_VarValue(iVar)
	} else {
		body  = "var " + name + " := " + DecodeValue_VarValue(iVar) ;+ ";"
	}
	return body
	
#defcfunc DecodeValue_VarValue int iVar,  local type, local value
	value = var_Get(iVar)
	type  = var_GetType(iVar)
;	return "{value: " + value + ", type: " + type + "}"		// ȈՕ\
	return DecodeEvalElem(type, value)
	
//------------------------------------------------
// ֐
//------------------------------------------------
#defcfunc DecodeValue_Func int iFunc,  local name, local prmc, local value, local body, local prmlist, local arglist, local iPlugin
	// ֐ => ̊֐ + ꂽXg
	if ( func_IsBound(iFunc) ) {
		arglist = func_GetArglist(iFunc)									// ꂽXg̎擾
		body    = DecodeValue_Func( FuncId(func_GetSuperFunc(iFunc)) )		// ̊֐̕\
		body   += " " + DecodeValue_Arglist( arglist )						// ꂽ\
		return body
	}
	
	name  = func_GetName(iFunc)
	if ( func_IsInternal(iFunc) ) {		// gݍ݊֐͖̂AOvOCȂ炻̃vOCŏCāAԂ
		iPlugin = func_GetPlugin(iFunc)
		return which( iPlugin >= PlugIn_Outer, plugin_GetName(iPlugin) + ".", "" ) + name
	}
	
	prmc    = func_GetCntPrms(iFunc)
	value   = func_GetBodyAsString(iFunc)
	prmlist = func_GetPrmlist(iFunc)
;	iEnv    = func_GetEnv(iFunc)
	
	StrIndentEachLine value
	
	body = strf("@func %s%s %s", name, DecodeValue_PrmList(prmlist, prmc), "{\n\t" + value + "\n}")
	
	return strf("#(%d)# %s", iFunc, body)
	
#defcfunc DecodeValue_Method int value,  local thisAssoc, local iFunc
	thisAssoc = pair_getLhs(value)
	iFunc     = FuncId(pair_getRhs(value))
	return "bind(" + DecodeValue_Func(iFunc) + ", (this)" /*+ DecodeValue_Assoc(thisAssoc)*/ + ")"
	
//------------------------------------------------
// ^l(bool)
//------------------------------------------------
#defcfunc DecodeValue_Bool int value
	switch ( value )
		case true:  return "true"
		case false: return "false"
		case indet: return "indet"
	swend
	assert
	
//------------------------------------------------
// l(int)
//------------------------------------------------
#defcfunc DecodeValue_Int int value
	return str(value)
;	if ( abs(value) <= 1 ) { return str(value) }
;	if ( HIWORD(value) == 0 ) {
;		return strf("%d #/0x%04X/#", value, value)		// word \
;	} else {
;		return strf("%d #/0x%08X/#", value, value)
;	}
	
//------------------------------------------------
// l(double)
//------------------------------------------------
#defcfunc DecodeValue_Double double value,  local coef, local b, local p
	switch ( value )
		case 0:    return "0.0"		// L萔
	;	case M_PI: return "PI"
	;	case M_E:  return "E"
		default:   return str(value)
	swend
	
//------------------------------------------------
// f(complex)
//------------------------------------------------
#defcfunc DecodeValue_Complex int iAssoc,  local vt, local size, local arg, local re, local im,  local sPolar, local sRect
	// Ɍ`
	size = complex_size(iAssoc) : if ( complex_IsRe(iAssoc) ) { return "complex(" + complex_CnvDown(iAssoc, vt) + ")" }
	arg  = complex_arg (iAssoc)
	sPolar = "(" + size + "" + arg + ")"
	
	// W`
	re = complex_re(iAssoc)
	im = complex_im(iAssoc)
	sRect = which( complex_IsPure(iAssoc), "(", "(" + re + " + ") + im + "i)"
	
	return sRect + " #(" + sPolar + ")#"
	
//------------------------------------------------
// 
//------------------------------------------------
#defcfunc DecodeValue_Block var block
	return "{ " + block_GetDecoded(block) + " }"
	
//------------------------------------------------
// Az
//------------------------------------------------
#defcfunc DecodeValue_Assoc int iAssoc,  local varlist, local namelist, local result, local iPrototype
	// internal assoc ? (AvOC̘AẑȂǂʎq\)
	switch ( iAssoc )
		case assocNull:         return "null"
		case stt_assoc_vector:  return "Vector"
		case stt_assoc_tuple:   return "Tuple"
		case stt_assoc_pair:    return "Pair"
		case stt_assoc_complex: return "Complex"
	swend
	
	sdim result
	
	// bLocal
#ifdef _DEBUG
	if ( assoc_IsLocal(iAssoc) ) { result += "\n# lcAssoc" }
#endif
	
	// prototype
	iPrototype = assoc_GetPrototypeAssoc(iAssoc)
	switch ( iPrototype )
		case stt_assoc_vector:  return DecodeValue_Vector(iAssoc)
		case stt_assoc_tuple:   return DecodeValue_Tuple(iAssoc)
		case stt_assoc_pair:    return DecodeValue_Pair(iAssoc)
		case stt_assoc_complex: return DecodeValue_Complex(iAssoc)
			
		case_if ( swthis != assocNull )		// prototype Ώo
			result += "\nprototype: " + DecodeValue_Assoc( iPrototype ) + ","
			swbreak
	swend
	
	assoc_GetMembers iAssoc, varlist, namelist
	repeat stat
		result += "\n" + namelist(cnt) + ": " + DecodeValue_VarValue(varlist(cnt)) + ","
	loop
	
:*LDecodeValue_Assoc_Output
	StrIndentEachLine result
	
	return "assoc(\n\t# (size: " + assoc_Size(iAssoc) + ")" + result + "\n)"
	
//------------------------------------------------
// vector
//------------------------------------------------
#defcfunc DecodeValue_Vector int self
	if ( self == assocNull ) { return "null" }
	return "[ " + DecodeValue_AbList( vector_GetImpl@MCVector(self) ) + " ]"
	
//------------------------------------------------
// tuple (<: vector)
//------------------------------------------------
#defcfunc DecodeValue_Tuple int self,  local len, local result
	if ( self == assocNull ) { return "null" }
	len = vector_Size(self)
	if ( len == 0 ) { return "tuple()" }
	if ( len == 1 ) { return "" + DecodeValue_VarValue( vector_Get(self, 0) ) + "," }
	return "( " + DecodeValue_AbList( vector_GetImpl@MCVector(self) ) + " )"
	
//------------------------------------------------
// pair
//------------------------------------------------
#defcfunc DecodeValue_Pair int self,  local lhs, local rhs
	lhs = assoc_Find(self, "lhs")
	rhs = assoc_Find(self, "rhs")
	return "(" + DecodeValue_VarValue(lhs) + ") : (" + DecodeValue_VarValue(rhs) + ")"
	
//------------------------------------------------
// vpeB
//------------------------------------------------
#defcfunc DecodeValue_Propaty int it,  local a, local lhs, local rhs
	lhs = pair_getLhs(it)
	rhs = pair_getRhs(it)
	
	a = DecodeValue_Assoc(rhs)
	a = "propaty" + strmid(a, 5, strlen(a) - 5)		// "assoc" ̕
	return a + which( lhs != assocNull, " #(bound with " + DecodeValue_Assoc(lhs) + ")#", "" )
	
//------------------------------------------------
// ex: list (abdata_list)
// 
// @ evf͕ϐ(iVar)
// @ l ", " ŋ؂ĕׂ
//------------------------------------------------
#defcfunc DecodeValue_AbList int list,  local result, local len, local tmp, local tmp_vt
	sdim result, 512
	len = list_size(list)
	
	repeat len
		if ( cnt != 0 ) { result += ", " }
		result += DecodeValue_VarValue( list_get(list, cnt) )
	loop
	
	return result
	
//------------------------------------------------
// ex: prmlist (abdata_list)
// 
// @ evf͎ʎq(str)
//------------------------------------------------
#defcfunc DecodeValue_PrmList var prmlist, int cntPrms,  local result, local len
	if ( prmlist == listNull ) {
		prmlist = new_list()
		repeat cntPrms : list_add prmlist, "_" + cnt : loop
	}
	
	sdim result, 256
	
	repeat cntPrms
		if ( cnt != 0 ) { result += ", " }
		result += list_get( prmlist, cnt )
	loop
	
	return "( " + result + " )"
	
//------------------------------------------------
// ex: arglist (vector)
// 
// @ evf͎(iVar)
//------------------------------------------------
#defcfunc DecodeValue_Arglist int arglist,  local result, local len, local tmp
	return DecodeValue_Vector(arglist)
	
//------------------------------------------------
// Qƈ
//------------------------------------------------
#defcfunc DecodeValue_RefArg int iRef,  local tmp
	tmp = pair_getLhs( iRef )
	return "ref( " + DecodeEvalElem( pair_getRhs(iRef), tmp ) + " )"
	
//##########################################################
//        Zq̕
//##########################################################
//------------------------------------------------
// decode PZq
//------------------------------------------------
#defcfunc DecodeOp_Uni int val
	switch ( val )
		case PrefixOp_Plus:  return "+"
		case PrefixOp_Minus: return "-"
		case PrefixOp_Inv:   return "/"
		case PrefixOp_Exp:   return "^"
		case PrefixOp_Sqrt:  return "//"
		case PrefixOp_Not:   return "~"
		case PrefixOp_Neg:   return "!"
		case PrefixOp_Func:  return "=>"
		case PrefixOp_Inc:   return "++"
		case PrefixOp_Dec:   return "--"
	;	case PrefixOp_Max:
		
		case PostfixOp_Fact:    return "!"
		case PostfixOp_Percent: return "%"
		case PostfixOp_Inc:     return "++"
		case PostfixOp_Dec:     return "--"
		case PostfixOp_Tuple:   return ","
		case PostfixOp_Snake:   return ";"
		case PostfixOp_Call:    return "[call]"
		case PostfixOp_Index:   return "[index]"
	;	case PostfixOp_Max:
		default:
			assert
	swend
	
//------------------------------------------------
// decode 񍀉Zq::u
//------------------------------------------------
#defcfunc DecodeOp_Bin int val
	switch ( val )
		case BinOp_Split: return ";"		// ꏈ
		
		case BinOp_Set:  return ":="
		case BinOp_Swap: return "<->"
		
		case BinOp_Tuple:  return ","
		
		case BinOp_Pair:   return ":"
		case BinOp_Which:  return "?"
		case BinOp_NullOr: return "??"
		
		case BinOp_Lambda: return "=>"
		
		case BinOp_LogImp: return "-->"
		case BinOp_LogOr:  return "||"
		case BinOp_LogXor: return "~~"
		case BinOp_LogAnd: return "&&"
		
		case BinOp_EqRf:   return "==="
		case BinOp_NeRf:   return "!=="
		case BinOp_Eq:     return "=="
		case BinOp_Ne:     return "!="
		case BinOp_Lt:     return "<"
		case BinOp_Gt:     return ">"
		case BinOp_LtEQ:   return "<="
		case BinOp_GtEQ:   return ">="
		case BinOp_Cmp:    return "<>"
		case BinOp_Belong: return "<:"
		
		case BinOp_ShiftL: return "<<"
		case BinOp_ShiftR: return ">>"
		case BinOp_BitOr:  return "|"
		case BinOp_BitXor: return "~"
		case BinOp_BitAnd: return "&"
		
		case BinOp_Add:   return "+"
		case BinOp_Sub:   return "-"
		case BinOp_Mul:   return "*"
		case BinOp_Div:   return "/"
		case BinOp_Mod:   return "%"
		case BinOp_Pow:   return "^"
		case BinOp_Root:  return "//"
		case BinOp_Trans: return "+>"		// ꏈ
		
		case BinOp_Assoc:     return "."
		case BinOp_AssocBind: return "->"
		
		default:
			assert
	swend
	
//##########################################################
//        o
//##########################################################
//------------------------------------------------
// ϐXgA֐Xg̏o
//------------------------------------------------
#deffunc StrCalcDebug_OutputGlobalDefinistion  local body, local name, local value, local type
	logmes "ESIuWFNg̏o"
	
	// ϐXg
	logmes "[Var]"
	foreach var_allInsts_var
		logmes DecodeValue_Var( cnt )
	loop
	
	// ֐Xg
	logmes "[Func]"
	foreach func_allInsts_var
		logmes DecodeValue_Func( cnt )
	loop
	
	logmes ""
	
	return
	
//------------------------------------------------
// ̕
//------------------------------------------------
#deffunc StrCalcDebug_OutputEnv var env
	
	return
	
//------------------------------------------------
// 
//------------------------------------------------

//------------------------------------------------
// 
//------------------------------------------------

//------------------------------------------------
// 
//------------------------------------------------

#global

#else

#define global StrCalcDebug_OutputGlobalDefinistion :

#endif

#endif
