// StrCalcLexer - getToken

#ifndef IG_MODULE_STRCALC_LEXER_GET_TOKEN_AS
#define IG_MODULE_STRCALC_LEXER_GET_TOKEN_AS

#include "lex_cutToken.as"

#module mod_StrCalcLexer_getToken

#include "header_inner.as"
#include "Mo/ctype.as"

#define SkipBlank index += CntSpaces(inText, index)

//------------------------------------------------
// 
//------------------------------------------------
#deffunc _init@mod_StrCalcLexer_getToken
	stt_operatorChars = ";:+-*/%^&|~=!<>.?"		// Zq̈ꕶڂƂȂ镶
	
	stt_nonOpChars       = "(){}[]@,"			// ̈ʒu  ̓YƑΉ
	stt_nonOpCharsTkType = TkType_ParenL, TkType_ParenR, TkType_BlockL, TkType_BlockR, TkType_ArrayL, TkType_ArrayR, TkType_Declare, TkType_Comma
	return
	
//------------------------------------------------
// ̃g[N؂o
// 
// @ łɊt\̓WJs
//------------------------------------------------
#deffunc StrCalcLexer_GetNextToken var out, var inText, var index,  local c, local c2, local c3, local radix
	
	c = peek(inText, index)
	
	// I[
	if ( c == 0 ) {
		index ++
		return TkType_None
	}
	
	// 
	if ( IsBlank(c) ) {
		CutBlank out, inText, index
		index += StrCalcLexer_GetLenCutLast()
		return TkType_Blank
	}
	
	// ʎq
	if ( IsIdentTop(c) || IsSJIS1st(c) ) {
		CutIdentifier out, inText, index
		index += StrCalcLexer_GetLenCutLast()
		return TkType_Ident
	}
	
	c2 = peek(inText, index + 1)
	
	// l
	if ( IsDigit(c) /*|| (c == '0' && IsRadixChar(c2)): ߏ*/ ) {
		gosub *LCutNumber
		return stat
	}
	
	// Rg
	if ( c == '#' ) {
		if ( c2 == '/' ) {
			CutCommentRange       out, inText, index, "#/", "/#"	// ͈ (lXgȂ)
		} elsif ( c2 == '(' ) {
			CutCommentRangeNested out, inText, index, "#(", ")#"	// ͈ (lXg)
		} elsif ( c2 == '{' ) {
			CutCommentRangeNested out, inText, index, "#{", "}#"	// ͈ (lXg)
		} else {
			CutCommentLine out, inText, index			// s
		}
		
		index += StrCalcLexer_GetLenCutLast()
		return TkType_Blank		// Rg͋󔒈
	}
	
	// 񃊃e
	if ( c == '\"' ) {			// s
		CutStringLine out, inText, index
		index += StrCalcLexer_GetLenCutLast()
		return TkType_String
		
	} elsif ( c == '<' && c2 == '\"' ) {
		CutStringRaw out, inText, index
		index += StrCalcLexer_GetLenCutLast()
		return TkType_String
	}
	
	// Zq
	wpoke out, 0, c
	if ( instr(stt_operatorChars, 0, out) >= 0 ) {	// ZqƂėLȕ
		if ( c2 != 0 ) {
			c3 = peek(inText, index + 2)
		}
		
		// 3oCgZq ( <->, (===, !==), --> )
		if ( (c == '<' && c2 == '-' && c3 == '>') || ((c == '=' || c == '!') && c2 == '=' && c3 == '=') || (c == '-' && c2 == '-' && c3 == '>') ) {
			lpoke out, 0, lpeek(inText, index) & 0x00FFFFFF		// 3 byte
			index += 3
			
		// 2oCgZq ( << Ȃǂ̓dA񕶎ڂ = ̉Zq, ->, =>, +>, <: )
		} else : if ( (IsDoubleOp(c) && c == c2) || ((c == ':' || c == '!' || c == '<' || c == '>' ) && c2 == '=') || ((c == '<' || c == '-' || c == '=' || c == '+') && c2 == '>') || (c == '<' && c2 == ':') ) {
			lpoke out, 0, lpeek(inText, index) & 0x0000FFFF		// 2 byte
			index += 2
			
		// 1oCgZq
		} else {
		;	wpoke out, , c		// 1 byte; ݍς
			index ++
		}
		
		return TkType_Operator
	}
	
	// ZqłȂL (out  c  wpoke ĂO)
	c3 = instr(stt_nonOpChars, 0, out)
	if ( c3 >= 0 ) {
		index ++
		return stt_nonOpCharsTkType(c3)
	}
	
	// ̑
	logmes strf("[Error] when lexer::getToken\nUnknown Char [%c][%d] [%d]", c, c, index)
	PutErrorMsg "߂łȂ(Token)B " + strf("'%c'", c), TkType_Error
	
;	return TkType_Error
	
//------------------------------------------------
// l̐؂o
//------------------------------------------------
*LCutNumber
	bDouble = false
	
	//  (K{)
	
	if ( c == '0' && IsRadixChar(c2) ) {
		index += 2										// 0   ̕
		radix  = RadixCharToRadix( c2 )					//   
		out    = CutNum_Radix( inText, index, radix )	// ̊̐𓾂
		index += StrCalcLexer_GetLenCutLast()
		if ( stat == 0 ) { PutError Error_Syntax }		// ̒0 => G[
		out    = ChangeRadix( strtrim(out, 3, '_'), radix, 10 )		// 10iɕϊ
		return TkType_Int
		
	} else {
	;	radix  = 10
		out    = CutNum_Dgt(inText, index)
		index += StrCalcLexer_GetLenCutLast()
	}
	
	// 
	
	if ( peek(inText, index) == '.' ) {
		c2 = peek(inText, index + 1)			// '.' ̒
		if ( IsDigit(c2) ) {
			bDouble = true
			
			index ++
			out   += "." + CutNum_Dgt(inText, index)
			index += StrCalcLexer_GetLenCutLast()
		}
	}
	
	// w
	
	if ( peek(inText, index) == 'e' ) {			//  e ̏ꍇAwt\Ƃ
		bDouble = true
		
		// e
		index ++								// e ̕
		out   += "e"
		
		// (+, -)
		c = peek(inText, index)					// e ̎
		if ( c == '+' || c == '-' ) {			// F߂
			index ++
			out += which( (c == '+'), "+", "-" )
		}
		
		// w
		out   += CutNum_Dgt(inText, index)
		index += StrCalcLexer_GetLenCutLast()
	}
	
	// 璷 _ 
	
	if ( instr(out, 0, "_") > 0 ) {
		out = strtrim(out, 3, '_')
	}
	
	return which( bDouble, TkType_Double, TkType_Int )
	
//------------------------------------------------
//   
// 
// @ ftHg 10
//------------------------------------------------
#defcfunc RadixCharToRadix int c
	switch ( c )
		case 'b': return  2
		case 't': return  3
		case 'o': return  8
		case 'd': return 10
		case 'x': return 16
		case 'v': return 32
		default:  assert
	swend
	
#global

_init@mod_StrCalcLexer_getToken

#endif
