// StrCalc Plugin - complex

#ifndef IG_STRCALC_PLUGIN_COMPLEX_AS
#define IG_STRCALC_PLUGIN_COMPLEX_AS

// Complex p̃vOC

#include "MCPlugin.as"
#include "MCComplex.as"

#module _plg_complex

#include "header_inner.as"

//------------------------------------------------
// 
//------------------------------------------------
#deffunc PluginComplex_Init  local env
	
	// namespace Complex
	plugin_New stt_env_global, "Complex"
		plugin_complex    = stat
		assoc_complex     = plugin_GetAssoc(plugin_complex)
		stt_assoc_complex = assoc_complex
		env               = plugin_GetEnv(plugin_complex)
		
	plugin_SetLabel plugin_complex, *LProcFunc
	
	plugin_DefFunc plugin_complex, "dup",      0, true : func_complex_dup     = stat
	
	plugin_DefFunc plugin_complex, "size_get", 0, true : func_complex_size_get = stat
	plugin_DefFunc plugin_complex, "size_set", 1, true : func_complex_size_set = stat
	plugin_DefFunc plugin_complex, "arg_get",  0, true : func_complex_arg_get  = stat
	plugin_DefFunc plugin_complex, "arg_set",  1, true : func_complex_arg_set  = stat
	plugin_DefFunc plugin_complex, "re_get",   0, true : func_complex_re_get   = stat
	plugin_DefFunc plugin_complex, "re_set",   1, true : func_complex_re_set   = stat
	plugin_DefFunc plugin_complex, "im_get",   0, true : func_complex_im_get   = stat
	plugin_DefFunc plugin_complex, "im_set",   1, true : func_complex_im_set   = stat
	
	plugin_DefFunc plugin_complex, "abs",      0, true : func_complex_abs = stat
	
	// vpeB
;	prop_assoc_complex_size = new_propaty_assoc( FuncValue(plugin_complex, func_complex_size_get), Valtype_Func, FuncValue(plugin_complex, func_complex_size_set), Valtype_Func, env )
;	prop_assoc_complex_arg  = new_propaty_assoc( FuncValue(plugin_complex, func_complex_arg_get),  Valtype_Func, FuncValue(plugin_complex, func_complex_arg_set),  Valtype_Func, env )
;	prop_assoc_complex_re   = new_propaty_assoc( FuncValue(plugin_complex, func_complex_re_get),   Valtype_Func, FuncValue(plugin_complex, func_complex_re_set),   Valtype_Func, env )
;	prop_assoc_complex_im   = new_propaty_assoc( FuncValue(plugin_complex, func_complex_im_get),   Valtype_Func, FuncValue(plugin_complex, func_complex_im_set),   Valtype_Func, env )
	plugin_DefPropaty plugin_complex, "size", func_complex_size_get, func_complex_size_set
	plugin_DefPropaty plugin_complex, "arg",  func_complex_arg_get,  func_complex_arg_set
	plugin_DefPropaty plugin_complex, "re",   func_complex_re_get,   func_complex_re_set
	plugin_DefPropaty plugin_complex, "im",   func_complex_im_get,   func_complex_im_set
	
	// ^ϊ֐
	plugin_DefFunc plugin_complex, "toBool",   0, true : func_complex_ToBool   = stat
	plugin_DefFunc plugin_complex, "toInt",    0, true : func_complex_ToInt    = stat
	plugin_DefFunc plugin_complex, "toDouble", 0, true : func_complex_ToDouble = stat
	
	// Z֐
	plugin_DefFunc plugin_complex, "opPlus",  0, true : func_complex_OpPlus  = stat
	plugin_DefFunc plugin_complex, "opMinus", 0, true : func_complex_OpMinus = stat
	plugin_DefFunc plugin_complex, "opInv",   0, true : func_complex_OpInv   = stat
	plugin_DefFunc plugin_complex, "opExp",   0, true : func_complex_OpExp   = stat
	plugin_DefFunc plugin_complex, "opSqrt",  0, true : func_complex_OpSqrt  = stat
	plugin_DefFunc plugin_complex, "opNot",   0, true : func_complex_OpNot   = stat
	plugin_DefFunc plugin_complex, "opInc",   0, true : func_complex_OpInc   = stat
	plugin_DefFunc plugin_complex, "opDec",   0, true : func_complex_OpDec   = stat
	
;	plugin_DefFunc plugin_complex, "opFact",    0, true : func_complex_OpFact    = stat	// K}֐
	plugin_DefFunc plugin_complex, "opPercent", 0, true : func_complex_OpPercent = stat
//	plugin_DefFunc plugin_complex, "opCall",   -1, true : func_complex_OpCall    = stat	// *
;	plugin_DefFunc plugin_complex, "opIndex",  -1, true : func_complex_OpIndex   = stat
	
	plugin_DefFunc plugin_complex, "opCmp",  1, true : func_complex_OpCmp  = stat
	
	plugin_DefFunc plugin_complex, "opAdd",  1, true : func_complex_OpAdd  = stat
	plugin_DefFunc plugin_complex, "opSub",  1, true : func_complex_OpSub  = stat
	plugin_DefFunc plugin_complex, "opMul",  1, true : func_complex_OpMul  = stat
	plugin_DefFunc plugin_complex, "opDiv",  1, true : func_complex_OpDiv  = stat
;	plugin_DefFunc plugin_complex, "opMod",  1, true : func_complex_OpMod  = stat
	plugin_DefFunc plugin_complex, "opPow",  1, true : func_complex_OpPow  = stat
	plugin_DefFunc plugin_complex, "opRoot", 1, true : func_complex_OpRoot = stat
	
	assoc_DefVar assoc_complex, "opTrans", FuncValue(plugin_complex, func_complex_OpMul), Valtype_Func
	assoc_DefVar assoc_complex, "opCall",  FuncValue(plugin_complex, func_complex_OpMul), Valtype_Func
	
	// (G[΍: Complex.size Ȃǂ #size v邽)
	assoc_DefVar assoc_complex, "#size", 0,   Valtype_Int
	assoc_DefVar assoc_complex, "#arg",  0.0, Valtype_Double
	
	// 萔
	assoc_DefVar    assoc_complex, "i", new_complex_unit( M_PI / 2, stt_env_global ), Valtype_Assoc
	assoc_ImportVar assoc_complex, "j", stat
	
	return plugin_complex
	
// vpeBAẑ𐶐
#defcfunc new_propaty_assoc int getter, int getter_vt, int setter, int setter_vt, int iEnv,  local self, local unbound
	self = new_assoc( iEnv )
	if ( getter != 0 ) { assoc_DefVar self, "get", getter, getter_vt }
	if ( setter != 0 ) { assoc_DefVar self, "set", setter, setter_vt }
	return self
	
// vOCɃvpeB`
#deffunc plugin_DefPropaty int self, str name, int fGetter, int fSetter,  \
	local getter, local setter, local prop_assoc, local unbound
	
	getter     = which( fGetter == 0, 0, FuncValue(self, fGetter) )
	setter     = which( fSetter == 0, 0, FuncValue(self, fSetter) )
	prop_assoc = new_propaty_assoc( getter, Valtype_Func, setter, Valtype_Func, plugin_GetEnv(self) )
	unbound    = assocNull
	assoc_DefVar plugin_GetAssoc(self), name, new_pair( unbound, prop_assoc ), Valtype_Propaty	// `
	return
	
// Complex Instance ɃvpeB`
;#deffunc plugin_complex_DefinePropaties int self,  local unbound
;	unbound = assocNull
;	assoc_DefVar self, "size", new_pair( unbound, prop_assoc_complex_size ), Valtype_Propaty
;	assoc_DefVar self, "arg",  new_pair( unbound, prop_assoc_complex_arg  ), Valtype_Propaty
;	assoc_DefVar self, "re",   new_pair( unbound, prop_assoc_complex_re   ), Valtype_Propaty
;	assoc_DefVar self, "im",   new_pair( unbound, prop_assoc_complex_im   ), Valtype_Propaty
;	return
	
//------------------------------------------------
// 
//------------------------------------------------
#define ctype SetResult(%1 = thisAssoc, %2 = Valtype_Assoc) result = (%1) : resVt = (%2)

#deffunc local _dummy_proc var lbProc, var thisEval, int thisAssoc, int iFunc, var result, var resVt, int arglist, int cntArgs, int iEnv,  \
	local tmp, local tmp_vt
	
*LProcFunc
	if ( thisAssoc == assocNull ) {
		PutError Error_InvalidValue
	}
	
	switch ( iFunc )
		
		// vpeB get/set
		case func_complex_abs:
		case func_complex_size_get:
			tmp = complex_size(thisAssoc)
			SetResult( tmp, which( vartype(tmp) == HSPVAR_FLAG_INT, Valtype_Int, Valtype_Double ) )
			swbreak
			
		case func_complex_size_set:
			tmp = evaler_GetValueFromArglist( thisEval, arglist, 0, tmp_vt, false )		// value
			if not( tmp_vt == Valtype_Int || tmp_vt == Valtype_Double ) { PutErrorNeed Valtype_Double }
			
			complex_set_size thisAssoc, tmp
			SetResult( tmp, tmp_vt )
			swbreak
			
		case func_complex_arg_get:
			SetResult( complex_arg(thisAssoc), Valtype_Double )
			swbreak
			
		case func_complex_arg_set:
			tmp = evaler_GetValueFromArglist( thisEval, arglist, 0, tmp_vt, false )		// value
			if not( tmp_vt == Valtype_Int || tmp_vt == Valtype_Double ) { PutErrorNeed Valtype_Double }
			
			complex_set_arg thisAssoc, tmp
			SetResult( tmp, tmp_vt )
			swbreak
			
		case func_complex_re_get:
			SetResult( complex_re(thisAssoc), Valtype_Double )
			swbreak
			
		case func_complex_re_set:
			tmp = evaler_GetValueFromArglist( thisEval, arglist, 0, tmp_vt, false )		// value
			if not( tmp_vt == Valtype_Int || tmp_vt == Valtype_Double ) { PutErrorNeed Valtype_Double }
			
			complex_set_re thisAssoc, tmp
			swbreak
			
		case func_complex_im_get:
			SetResult( complex_im(thisAssoc), Valtype_Double )
			swbreak
			
		case func_complex_im_set:
			tmp = evaler_GetValueFromArglist( thisEval, arglist, 0, tmp_vt, false )		// value
			if not( tmp_vt == Valtype_Int || tmp_vt == Valtype_Double ) { PutErrorNeed Valtype_Double }
			
			complex_set_im thisAssoc, tmp
			swbreak
			
		// o֐
		case func_complex_dup:
			SetResult( complex_dup(thisAssoc) )
			swbreak
			
		// ^ϊ֐
		case func_complex_ToBool: SetResult( complex_size(thisAssoc) != 0, Valtype_Bool ) : swbreak
		case func_complex_ToInt:
		case func_complex_ToDouble:
			tmp = complex_arg(thisAssoc)
			if ( tmp \ M_PI == 0 ) {		// 
				if ( swthis == func_complex_ToInt ) {
					SetResult(    int( complex_size(thisAssoc) ) * which( tmp == 0, 1, -1 ), Valtype_Int )		// _ȉ͐؂藎Ƃ
				} else {
					SetResult( double( complex_size(thisAssoc) ) * which( tmp == 0, 1.0, -1.0 ), Valtype_Double )
				}
			} else {
				PutErrorMsg "" + which( swthis == func_complex_ToInt, "", "" ) + "ɕϊłȂB\n" + DecodeValue_Complex( thisAssoc )
			}
			swbreak
			
		// Z֐ => Dup() ̂ɑ΂鉉Z
		case_if ( func_complex_OpPlus <= swthis ):
			if ( not(iFunc == func_complex_OpCmp) ) {	// rȊO
				result = complex_Dup(thisAssoc)			// Ԓlp Dup 𐶐
				resVt  = Valtype_Assoc
			}
			
			if ( iFunc >= func_complex_OpCmp ) {		// , Cmp ȊO
				tmp = evaler_GetValueFromArglist( thisEval, arglist, 0, tmp_vt, false )		// value
				if ( tmp_vt == Valtype_Int || tmp_vt == Valtype_Double ) {
					tmp = new_complex_real( double(tmp), iEnv )
				} elsif ( IsComplex(tmp, tmp_vt) ) {
					;
				} else {
					PutError Error_NeedComplex
				}
			}
			
			switch ( iFunc )
				case func_complex_OpPlus:  swbreak
				case func_complex_OpMinus: complex_Minus     result : swbreak
				case func_complex_OpInv:   complex_Inv       result : swbreak
				case func_complex_OpExp:   complex_Exp       result : swbreak
				case func_complex_OpSqrt:  complex_Sqrt      result : swbreak
				case func_complex_OpNot:   complex_Conjugate result : swbreak		// ~z = (z ̋𕡑f)
					
				case func_complex_OpInc:
				case func_complex_OpDec:
					complex_set_size result, which( iFunc == func_complex_OpInc, complex_size(result) + 1, complex_size(result) - 1 )
					swbreak
					
		;		case func_complex_OpFact:
				case func_complex_OpPercent: complex_MulWithReal result, 0.01 : swbreak		// z% = z / 100;
				
		;		case func_complex_OpCall:
		;		case func_complex_OpIndex:
				
				case func_complex_OpCmp:
					SetResult( complex_Cmp(thisAssoc, tmp), Valtype_Int ) 
					swbreak
					
				case func_complex_OpAdd: complex_Add result, tmp : swbreak
				case func_complex_OpSub: complex_Sub result, tmp : swbreak
				case func_complex_OpMul: complex_Mul result, tmp : swbreak
				case func_complex_OpDiv:
					if ( complex_size(tmp) == 0 ) { PutError Error_DivBy0 }
					complex_Div result, tmp
					swbreak
					
		;		case func_complex_OpMod:
				case func_complex_OpPow: complex_Pow result, tmp : swbreak
				case func_complex_OpRoot:
					IntSwap tmp, result				// (result, tmp) = (original y, dup this=x)
					result = complex_Dup(result)
					complex_Inv tmp
					complex_Pow result, tmp			// x//y = y^(1/x)
					swbreak
					
			swend
			
			StrCalc_ArithCnvDown result, resVt
			SetResult( result, resVt )
			swbreak
			
		default:
			assert
	swend
	return
	
#global

#endif
